/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * ApiRelease details.
 *
 * @extends models['Resource']
 */
class ApiReleaseContract extends models['Resource'] {
  /**
   * Create a ApiReleaseContract.
   * @property {string} [apiId] Identifier of the API the release belongs to.
   * @property {date} [createdDateTime] The time the API was released. The date
   * conforms to the following format: yyyy-MM-ddTHH:mm:ssZ as specified by the
   * ISO 8601 standard.
   * @property {date} [updatedDateTime] The time the API release was updated.
   * @property {string} [notes] Release Notes
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApiReleaseContract
   *
   * @returns {object} metadata of ApiReleaseContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiReleaseContract',
      type: {
        name: 'Composite',
        className: 'ApiReleaseContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          apiId: {
            required: false,
            serializedName: 'properties.apiId',
            type: {
              name: 'String'
            }
          },
          createdDateTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.createdDateTime',
            type: {
              name: 'DateTime'
            }
          },
          updatedDateTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.updatedDateTime',
            type: {
              name: 'DateTime'
            }
          },
          notes: {
            required: false,
            serializedName: 'properties.notes',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiReleaseContract;
