/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An API Version Set contains the common configuration for a set of API
 * Versions relating
 *
 */
class ApiVersionSetContractDetails {
  /**
   * Create a ApiVersionSetContractDetails.
   * @property {string} [id] Identifier for existing API Version Set. Omit this
   * value to create a new Version Set.
   * @property {string} [name] The display Name of the API Version Set.
   * @property {string} [description] Description of API Version Set.
   * @property {string} [versioningScheme] An value that determines where the
   * API Version identifer will be located in a HTTP request. Possible values
   * include: 'Segment', 'Query', 'Header'
   * @property {string} [versionQueryName] Name of query parameter that
   * indicates the API Version if versioningScheme is set to `query`.
   * @property {string} [versionHeaderName] Name of HTTP header parameter that
   * indicates the API Version if versioningScheme is set to `header`.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiVersionSetContractDetails
   *
   * @returns {object} metadata of ApiVersionSetContractDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiVersionSetContractDetails',
      type: {
        name: 'Composite',
        className: 'ApiVersionSetContractDetails',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          versioningScheme: {
            required: false,
            serializedName: 'versioningScheme',
            type: {
              name: 'String'
            }
          },
          versionQueryName: {
            required: false,
            serializedName: 'versionQueryName',
            type: {
              name: 'String'
            }
          },
          versionHeaderName: {
            required: false,
            serializedName: 'versionHeaderName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiVersionSetContractDetails;
