/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Cache details.
 *
 * @extends models['Resource']
 */
class CacheContract extends models['Resource'] {
  /**
   * Create a CacheContract.
   * @property {string} [description] Cache description
   * @property {string} connectionString Runtime connection string to cache
   * @property {string} [resourceId] Original uri of entity in external system
   * cache points to
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CacheContract
   *
   * @returns {object} metadata of CacheContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CacheContract',
      type: {
        name: 'Composite',
        className: 'CacheContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            constraints: {
              MaxLength: 2000
            },
            type: {
              name: 'String'
            }
          },
          connectionString: {
            required: true,
            serializedName: 'properties.connectionString',
            constraints: {
              MaxLength: 300
            },
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'properties.resourceId',
            constraints: {
              MaxLength: 2000
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CacheContract;
