/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters supplied to the Create Group operation.
 *
 */
class GroupCreateParameters {
  /**
   * Create a GroupCreateParameters.
   * @property {string} displayName Group name.
   * @property {string} [description] Group description.
   * @property {string} [type] Group type. Possible values include: 'custom',
   * 'system', 'external'
   * @property {string} [externalId] Identifier of the external groups, this
   * property contains the id of the group from the external identity provider,
   * e.g. for Azure Active Directory
   * `aad://<tenant>.onmicrosoft.com/groups/<group object id>`; otherwise the
   * value is null.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GroupCreateParameters
   *
   * @returns {object} metadata of GroupCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GroupCreateParameters',
      type: {
        name: 'Composite',
        className: 'GroupCreateParameters',
        modelProperties: {
          displayName: {
            required: true,
            serializedName: 'properties.displayName',
            constraints: {
              MaxLength: 300,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'properties.type',
            type: {
              name: 'Enum',
              allowedValues: [ 'custom', 'system', 'external' ]
            }
          },
          externalId: {
            required: false,
            serializedName: 'properties.externalId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GroupCreateParameters;
