/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Http message diagnostic settings.
 *
 */
class HttpMessageDiagnostic {
  /**
   * Create a HttpMessageDiagnostic.
   * @property {array} [headers] Array of HTTP Headers to log.
   * @property {object} [body] Body logging settings.
   * @property {number} [body.bytes] Number of request body bytes to log.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpMessageDiagnostic
   *
   * @returns {object} metadata of HttpMessageDiagnostic
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpMessageDiagnostic',
      type: {
        name: 'Composite',
        className: 'HttpMessageDiagnostic',
        modelProperties: {
          headers: {
            required: false,
            serializedName: 'headers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          body: {
            required: false,
            serializedName: 'body',
            type: {
              name: 'Composite',
              className: 'BodyDiagnosticSettings'
            }
          }
        }
      }
    };
  }
}

module.exports = HttpMessageDiagnostic;
