/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Issue update Parameters.
 *
 */
class IssueUpdateContract {
  /**
   * Create a IssueUpdateContract.
   * @property {date} [createdDate] Date and time when the issue was created.
   * @property {string} [state] Status of the issue. Possible values include:
   * 'proposed', 'open', 'removed', 'resolved', 'closed'
   * @property {string} [apiId] A resource identifier for the API the issue was
   * created for.
   * @property {string} [title] The issue title.
   * @property {string} [description] Text describing the issue.
   * @property {string} [userId] A resource identifier for the user created the
   * issue.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IssueUpdateContract
   *
   * @returns {object} metadata of IssueUpdateContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IssueUpdateContract',
      type: {
        name: 'Composite',
        className: 'IssueUpdateContract',
        modelProperties: {
          createdDate: {
            required: false,
            serializedName: 'properties.createdDate',
            type: {
              name: 'DateTime'
            }
          },
          state: {
            required: false,
            serializedName: 'properties.state',
            type: {
              name: 'String'
            }
          },
          apiId: {
            required: false,
            serializedName: 'properties.apiId',
            type: {
              name: 'String'
            }
          },
          title: {
            required: false,
            serializedName: 'properties.title',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          userId: {
            required: false,
            serializedName: 'properties.userId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IssueUpdateContract;
