/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * REST API operation
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @property {string} [name] Operation name:
   * {provider}/{resource}/{operation}
   * @property {object} [display] The object that describes the operation.
   * @property {string} [display.provider] Friendly name of the resource
   * provider
   * @property {string} [display.operation] Operation type: read, write,
   * delete, listKeys/action, etc.
   * @property {string} [display.resource] Resource type on which the operation
   * is performed.
   * @property {string} [display.description] Friendly name of the operation
   * @property {string} [origin] The operation origin.
   * @property {object} [properties] The operation properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
