/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Operation Entity contract Properties.
 *
 */
class OperationTagResourceContractProperties {
  /**
   * Create a OperationTagResourceContractProperties.
   * @property {string} [id] Identifier of the operation in form
   * /operations/{operationId}.
   * @property {string} [name] Operation name.
   * @property {string} [apiName] Api Name.
   * @property {string} [apiRevision] Api Revision.
   * @property {string} [apiVersion] Api Version.
   * @property {string} [description] Operation Description.
   * @property {string} [method] A Valid HTTP Operation Method. Typical Http
   * Methods like GET, PUT, POST but not limited by only them.
   * @property {string} [urlTemplate] Relative URL template identifying the
   * target resource for this operation. May include parameters. Example:
   * /customers/{cid}/orders/{oid}/?date={date}
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationTagResourceContractProperties
   *
   * @returns {object} metadata of OperationTagResourceContractProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationTagResourceContractProperties',
      type: {
        name: 'Composite',
        className: 'OperationTagResourceContractProperties',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          apiName: {
            required: false,
            readOnly: true,
            serializedName: 'apiName',
            type: {
              name: 'String'
            }
          },
          apiRevision: {
            required: false,
            readOnly: true,
            serializedName: 'apiRevision',
            type: {
              name: 'String'
            }
          },
          apiVersion: {
            required: false,
            readOnly: true,
            serializedName: 'apiVersion',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          method: {
            required: false,
            readOnly: true,
            serializedName: 'method',
            type: {
              name: 'String'
            }
          },
          urlTemplate: {
            required: false,
            readOnly: true,
            serializedName: 'urlTemplate',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationTagResourceContractProperties;
