/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recipient Email details.
 *
 * @extends models['Resource']
 */
class RecipientEmailContract extends models['Resource'] {
  /**
   * Create a RecipientEmailContract.
   * @property {string} [email] User Email subscribed to notification.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecipientEmailContract
   *
   * @returns {object} metadata of RecipientEmailContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecipientEmailContract',
      type: {
        name: 'Composite',
        className: 'RecipientEmailContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          email: {
            required: false,
            serializedName: 'properties.email',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RecipientEmailContract;
