/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Recipient User details.
 *
 * @extends models['Resource']
 */
class RecipientUserContract extends models['Resource'] {
  /**
   * Create a RecipientUserContract.
   * @property {string} [userId] API Management UserId subscribed to
   * notification.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecipientUserContract
   *
   * @returns {object} metadata of RecipientUserContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecipientUserContract',
      type: {
        name: 'Composite',
        className: 'RecipientUserContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          userId: {
            required: false,
            serializedName: 'properties.userId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RecipientUserContract;
