/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * AI related application info for an event result
 *
 */
class EventsAiInfo {
  /**
   * Create a EventsAiInfo.
   * @member {string} [iKey] iKey of the app
   * @member {string} [appName] Name of the application
   * @member {string} [appId] ID of the application
   * @member {string} [sdkVersion] SDK version of the application
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsAiInfo
   *
   * @returns {object} metadata of EventsAiInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'eventsAiInfo',
      type: {
        name: 'Composite',
        className: 'EventsAiInfo',
        modelProperties: {
          iKey: {
            required: false,
            serializedName: 'iKey',
            type: {
              name: 'String'
            }
          },
          appName: {
            required: false,
            serializedName: 'appName',
            type: {
              name: 'String'
            }
          },
          appId: {
            required: false,
            serializedName: 'appId',
            type: {
              name: 'String'
            }
          },
          sdkVersion: {
            required: false,
            serializedName: 'sdkVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsAiInfo;
