/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The dependency info
 *
 */
class EventsDependencyInfo {
  /**
   * Create a EventsDependencyInfo.
   * @member {string} [target] The target of the dependency
   * @member {string} [data] The data of the dependency
   * @member {string} [success] Indicates if the dependency was successful
   * @member {number} [duration] The duration of the dependency
   * @member {string} [performanceBucket] The performance bucket of the
   * dependency
   * @member {string} [resultCode] The result code of the dependency
   * @member {string} [type] The type of the dependency
   * @member {string} [name] The name of the dependency
   * @member {string} [id] The ID of the dependency
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsDependencyInfo
   *
   * @returns {object} metadata of EventsDependencyInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'eventsDependencyInfo',
      type: {
        name: 'Composite',
        className: 'EventsDependencyInfo',
        modelProperties: {
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          data: {
            required: false,
            serializedName: 'data',
            type: {
              name: 'String'
            }
          },
          success: {
            required: false,
            serializedName: 'success',
            type: {
              name: 'String'
            }
          },
          duration: {
            required: false,
            serializedName: 'duration',
            type: {
              name: 'Number'
            }
          },
          performanceBucket: {
            required: false,
            serializedName: 'performanceBucket',
            type: {
              name: 'String'
            }
          },
          resultCode: {
            required: false,
            serializedName: 'resultCode',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsDependencyInfo;
