/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the body of a purge request for an App Insights component
 *
 */
class ComponentPurgeBody {
  /**
   * Create a ComponentPurgeBody.
   * @member {string} table Table from which to purge data.
   * @member {array} filters The set of columns and filters (queries) to run
   * over them to purge the resulting data.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ComponentPurgeBody
   *
   * @returns {object} metadata of ComponentPurgeBody
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ComponentPurgeBody',
      type: {
        name: 'Composite',
        className: 'ComponentPurgeBody',
        modelProperties: {
          table: {
            required: true,
            serializedName: 'table',
            type: {
              name: 'String'
            }
          },
          filters: {
            required: true,
            serializedName: 'filters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ComponentPurgeBodyFiltersElementType',
                  type: {
                    name: 'Composite',
                    className: 'ComponentPurgeBodyFilters'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ComponentPurgeBody;
