/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Work item configuration creation payload
 *
 */
class WorkItemCreateConfiguration {
  /**
   * Create a WorkItemCreateConfiguration.
   * @member {string} [connectorId] Unique connector id
   * @member {string} [connectorDataConfiguration] Serialized JSON object for
   * detaile d properties
   * @member {boolean} [validateOnly] Boolean indicating validate only
   * @member {string} [workItemProperties] Custom work item properties
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkItemCreateConfiguration
   *
   * @returns {object} metadata of WorkItemCreateConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkItemCreateConfiguration',
      type: {
        name: 'Composite',
        className: 'WorkItemCreateConfiguration',
        modelProperties: {
          connectorId: {
            required: false,
            serializedName: 'ConnectorId',
            type: {
              name: 'String'
            }
          },
          connectorDataConfiguration: {
            required: false,
            serializedName: 'ConnectorDataConfiguration',
            type: {
              name: 'String'
            }
          },
          validateOnly: {
            required: false,
            serializedName: 'ValidateOnly',
            type: {
              name: 'Boolean'
            }
          },
          workItemProperties: {
            required: false,
            serializedName: 'WorkItemProperties',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkItemCreateConfiguration;
