/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Deny Assignments filter
 *
 */
class DenyAssignmentFilter {
  /**
   * Create a DenyAssignmentFilter.
   * @property {string} [denyAssignmentName] Return deny assignment with
   * specified name.
   * @property {string} [principalId] Return all deny assignments where the
   * specified principal is listed in the principals list of deny assignments.
   * @property {string} [gdprExportPrincipalId] Return all deny assignments
   * where the specified principal is listed either in the principals list or
   * exclude principals list of deny assignments.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DenyAssignmentFilter
   *
   * @returns {object} metadata of DenyAssignmentFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DenyAssignmentFilter',
      type: {
        name: 'Composite',
        className: 'DenyAssignmentFilter',
        modelProperties: {
          denyAssignmentName: {
            required: false,
            serializedName: 'denyAssignmentName',
            type: {
              name: 'String'
            }
          },
          principalId: {
            required: false,
            serializedName: 'principalId',
            type: {
              name: 'String'
            }
          },
          gdprExportPrincipalId: {
            required: false,
            serializedName: 'gdprExportPrincipalId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DenyAssignmentFilter;
