/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Role definition permissions.
 *
 */
class Permission {
  /**
   * Create a Permission.
   * @property {array} [actions] Allowed actions.
   * @property {array} [notActions] Denied actions.
   * @property {array} [dataActions] Allowed Data actions.
   * @property {array} [notDataActions] Denied Data actions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Permission
   *
   * @returns {object} metadata of Permission
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Permission',
      type: {
        name: 'Composite',
        className: 'Permission',
        modelProperties: {
          actions: {
            required: false,
            serializedName: 'actions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          notActions: {
            required: false,
            serializedName: 'notActions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          dataActions: {
            required: false,
            serializedName: 'dataActions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          notDataActions: {
            required: false,
            serializedName: 'notDataActions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Permission;
