/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Sku = require('./sku');
exports.Resource = require('./resource');
exports.TrackedResource = require('./trackedResource');
exports.AutomationAccount = require('./automationAccount');
exports.AutomationAccountCreateOrUpdateParameters = require('./automationAccountCreateOrUpdateParameters');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.Statistics = require('./statistics');
exports.UsageCounterName = require('./usageCounterName');
exports.Usage = require('./usage');
exports.Key = require('./key');
exports.KeyListResult = require('./keyListResult');
exports.AutomationAccountUpdateParameters = require('./automationAccountUpdateParameters');
exports.ProxyResource = require('./proxyResource');
exports.ErrorResponse = require('./errorResponse');
exports.CertificateCreateOrUpdateParameters = require('./certificateCreateOrUpdateParameters');
exports.Certificate = require('./certificate');
exports.CertificateUpdateParameters = require('./certificateUpdateParameters');
exports.ConnectionTypeAssociationProperty = require('./connectionTypeAssociationProperty');
exports.ConnectionCreateOrUpdateParameters = require('./connectionCreateOrUpdateParameters');
exports.Connection = require('./connection');
exports.ConnectionUpdateParameters = require('./connectionUpdateParameters');
exports.FieldDefinition = require('./fieldDefinition');
exports.ConnectionType = require('./connectionType');
exports.ConnectionTypeCreateOrUpdateParameters = require('./connectionTypeCreateOrUpdateParameters');
exports.CredentialCreateOrUpdateParameters = require('./credentialCreateOrUpdateParameters');
exports.Credential = require('./credential');
exports.CredentialUpdateParameters = require('./credentialUpdateParameters');
exports.ContentHash = require('./contentHash');
exports.ContentSource = require('./contentSource');
exports.DscConfigurationParameter = require('./dscConfigurationParameter');
exports.DscConfigurationCreateOrUpdateParameters = require('./dscConfigurationCreateOrUpdateParameters');
exports.DscConfiguration = require('./dscConfiguration');
exports.DscConfigurationUpdateParameters = require('./dscConfigurationUpdateParameters');
exports.RunAsCredentialAssociationProperty = require('./runAsCredentialAssociationProperty');
exports.HybridRunbookWorker = require('./hybridRunbookWorker');
exports.HybridRunbookWorkerGroup = require('./hybridRunbookWorkerGroup');
exports.HybridRunbookWorkerGroupUpdateParameters = require('./hybridRunbookWorkerGroupUpdateParameters');
exports.ScheduleAssociationProperty = require('./scheduleAssociationProperty');
exports.RunbookAssociationProperty = require('./runbookAssociationProperty');
exports.JobSchedule = require('./jobSchedule');
exports.JobScheduleCreateParameters = require('./jobScheduleCreateParameters');
exports.LinkedWorkspace = require('./linkedWorkspace');
exports.ActivityParameterValidationSet = require('./activityParameterValidationSet');
exports.ActivityParameter = require('./activityParameter');
exports.ActivityParameterSet = require('./activityParameterSet');
exports.ActivityOutputType = require('./activityOutputType');
exports.Activity = require('./activity');
exports.ModuleErrorInfo = require('./moduleErrorInfo');
exports.ContentLink = require('./contentLink');
exports.Module = require('./module');
exports.ModuleCreateOrUpdateParameters = require('./moduleCreateOrUpdateParameters');
exports.ModuleUpdateParameters = require('./moduleUpdateParameters');
exports.TypeField = require('./typeField');
exports.AdvancedScheduleMonthlyOccurrence = require('./advancedScheduleMonthlyOccurrence');
exports.AdvancedSchedule = require('./advancedSchedule');
exports.ScheduleCreateOrUpdateParameters = require('./scheduleCreateOrUpdateParameters');
exports.ScheduleProperties = require('./scheduleProperties');
exports.Schedule = require('./schedule');
exports.ScheduleUpdateParameters = require('./scheduleUpdateParameters');
exports.VariableCreateOrUpdateParameters = require('./variableCreateOrUpdateParameters');
exports.Variable = require('./variable');
exports.VariableUpdateParameters = require('./variableUpdateParameters');
exports.Webhook = require('./webhook');
exports.WebhookUpdateParameters = require('./webhookUpdateParameters');
exports.WebhookCreateOrUpdateParameters = require('./webhookCreateOrUpdateParameters');
exports.Watcher = require('./watcher');
exports.WatcherUpdateParameters = require('./watcherUpdateParameters');
exports.WindowsProperties = require('./windowsProperties');
exports.LinuxProperties = require('./linuxProperties');
exports.TagSettingsProperties = require('./tagSettingsProperties');
exports.AzureQueryProperties = require('./azureQueryProperties');
exports.TargetProperties = require('./targetProperties');
exports.UpdateConfiguration = require('./updateConfiguration');
exports.TaskProperties = require('./taskProperties');
exports.SoftwareUpdateConfigurationTasks = require('./softwareUpdateConfigurationTasks');
exports.SoftwareUpdateConfiguration = require('./softwareUpdateConfiguration');
exports.CollectionItemUpdateConfiguration = require('./collectionItemUpdateConfiguration');
exports.SoftwareUpdateConfigurationCollectionItem = require('./softwareUpdateConfigurationCollectionItem');
exports.SoftwareUpdateConfigurationListResult = require('./softwareUpdateConfigurationListResult');
exports.UpdateConfigurationNavigation = require('./updateConfigurationNavigation');
exports.SoftareUpdateConfigurationRunTaskProperties = require('./softareUpdateConfigurationRunTaskProperties');
exports.SoftareUpdateConfigurationRunTasks = require('./softareUpdateConfigurationRunTasks');
exports.SoftwareUpdateConfigurationRun = require('./softwareUpdateConfigurationRun');
exports.SoftwareUpdateConfigurationRunListResult = require('./softwareUpdateConfigurationRunListResult');
exports.JobNavigation = require('./jobNavigation');
exports.SoftwareUpdateConfigurationMachineRun = require('./softwareUpdateConfigurationMachineRun');
exports.SoftwareUpdateConfigurationMachineRunListResult = require('./softwareUpdateConfigurationMachineRunListResult');
exports.SourceControl = require('./sourceControl');
exports.SourceControlSecurityTokenProperties = require('./sourceControlSecurityTokenProperties');
exports.SourceControlUpdateParameters = require('./sourceControlUpdateParameters');
exports.SourceControlCreateOrUpdateParameters = require('./sourceControlCreateOrUpdateParameters');
exports.SourceControlSyncJob = require('./sourceControlSyncJob');
exports.SourceControlSyncJobCreateParameters = require('./sourceControlSyncJobCreateParameters');
exports.SourceControlSyncJobById = require('./sourceControlSyncJobById');
exports.SourceControlSyncJobStream = require('./sourceControlSyncJobStream');
exports.SourceControlSyncJobStreamById = require('./sourceControlSyncJobStreamById');
exports.JobStream = require('./jobStream');
exports.Job = require('./job');
exports.JobCollectionItem = require('./jobCollectionItem');
exports.JobCreateParameters = require('./jobCreateParameters');
exports.DscReportError = require('./dscReportError');
exports.DscReportResourceNavigation = require('./dscReportResourceNavigation');
exports.DscReportResource = require('./dscReportResource');
exports.DscMetaConfiguration = require('./dscMetaConfiguration');
exports.DscNodeReport = require('./dscNodeReport');
exports.AgentRegistrationKeys = require('./agentRegistrationKeys');
exports.AgentRegistration = require('./agentRegistration');
exports.DscNodeExtensionHandlerAssociationProperty = require('./dscNodeExtensionHandlerAssociationProperty');
exports.DscNode = require('./dscNode');
exports.AgentRegistrationRegenerateKeyParameter = require('./agentRegistrationRegenerateKeyParameter');
exports.DscNodeUpdateParametersProperties = require('./dscNodeUpdateParametersProperties');
exports.DscNodeUpdateParameters = require('./dscNodeUpdateParameters');
exports.DscConfigurationAssociationProperty = require('./dscConfigurationAssociationProperty');
exports.DscCompilationJob = require('./dscCompilationJob');
exports.DscCompilationJobCreateParameters = require('./dscCompilationJobCreateParameters');
exports.DscNodeConfiguration = require('./dscNodeConfiguration');
exports.DscNodeConfigurationCreateOrUpdateParameters = require('./dscNodeConfigurationCreateOrUpdateParameters');
exports.NodeCountProperties = require('./nodeCountProperties');
exports.NodeCount = require('./nodeCount');
exports.NodeCounts = require('./nodeCounts');
exports.RunbookParameter = require('./runbookParameter');
exports.RunbookDraft = require('./runbookDraft');
exports.Runbook = require('./runbook');
exports.RunbookCreateOrUpdateParameters = require('./runbookCreateOrUpdateParameters');
exports.RunbookUpdateParameters = require('./runbookUpdateParameters');
exports.RunbookDraftUndoEditResult = require('./runbookDraftUndoEditResult');
exports.TestJobCreateParameters = require('./testJobCreateParameters');
exports.TestJob = require('./testJob');
exports.RunbookCreateOrUpdateDraftProperties = require('./runbookCreateOrUpdateDraftProperties');
exports.RunbookCreateOrUpdateDraftParameters = require('./runbookCreateOrUpdateDraftParameters');
exports.PythonPackageCreateParameters = require('./pythonPackageCreateParameters');
exports.PythonPackageUpdateParameters = require('./pythonPackageUpdateParameters');
exports.AutomationAccountListResult = require('./automationAccountListResult');
exports.OperationListResult = require('./operationListResult');
exports.StatisticsListResult = require('./statisticsListResult');
exports.UsageListResult = require('./usageListResult');
exports.CertificateListResult = require('./certificateListResult');
exports.ConnectionListResult = require('./connectionListResult');
exports.ConnectionTypeListResult = require('./connectionTypeListResult');
exports.CredentialListResult = require('./credentialListResult');
exports.DscConfigurationListResult = require('./dscConfigurationListResult');
exports.HybridRunbookWorkerGroupsListResult = require('./hybridRunbookWorkerGroupsListResult');
exports.JobScheduleListResult = require('./jobScheduleListResult');
exports.ActivityListResult = require('./activityListResult');
exports.ModuleListResult = require('./moduleListResult');
exports.TypeFieldListResult = require('./typeFieldListResult');
exports.ScheduleListResult = require('./scheduleListResult');
exports.VariableListResult = require('./variableListResult');
exports.WebhookListResult = require('./webhookListResult');
exports.WatcherListResult = require('./watcherListResult');
exports.SourceControlListResult = require('./sourceControlListResult');
exports.SourceControlSyncJobListResult = require('./sourceControlSyncJobListResult');
exports.SourceControlSyncJobStreamsListBySyncJob = require('./sourceControlSyncJobStreamsListBySyncJob');
exports.JobListResultV2 = require('./jobListResultV2');
exports.JobStreamListResult = require('./jobStreamListResult');
exports.DscNodeListResult = require('./dscNodeListResult');
exports.DscNodeReportListResult = require('./dscNodeReportListResult');
exports.DscCompilationJobListResult = require('./dscCompilationJobListResult');
exports.DscNodeConfigurationListResult = require('./dscNodeConfigurationListResult');
exports.RunbookListResult = require('./runbookListResult');
