/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The response model for the list job operation.
 *
 */
class JobListResult {
  /**
   * Create a JobListResult.
   * @member {array} [value] Gets or sets a list of jobs.
   * @member {string} [nextLink] Gets or sets the next link.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobListResult
   *
   * @returns {object} metadata of JobListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobListResult',
      type: {
        name: 'Composite',
        className: 'JobListResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JobElementType',
                  type: {
                    name: 'Composite',
                    className: 'Job'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobListResult;
