/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a WatcherUpdateParameters.
 */
class WatcherUpdateParameters {
  /**
   * Create a WatcherUpdateParameters.
   * @member {number} [executionFrequencyInSeconds] Gets or sets the frequency
   * at which the watcher is invoked.
   * @member {string} [name] Gets or sets the name of the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WatcherUpdateParameters
   *
   * @returns {object} metadata of WatcherUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WatcherUpdateParameters',
      type: {
        name: 'Composite',
        className: 'WatcherUpdateParameters',
        modelProperties: {
          executionFrequencyInSeconds: {
            required: false,
            serializedName: 'properties.executionFrequencyInSeconds',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WatcherUpdateParameters;
