/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Contains information about Jobs that have been and will be run
 * under a Job Schedule.
  *
 */
class JobScheduleExecutionInformation {
  /**
   * Create a JobScheduleExecutionInformation.
   * @property {date} [nextRunTime] The next time at which a Job will be
   * created under this schedule. This property is meaningful only if the
   * schedule is in the active state when the time comes around. For example,
   * if the schedule is disabled, no Job will be created at nextRunTime unless
   * the Job is enabled before then.
   * @property {object} [recentJob] Information about the most recent Job under
   * the Job Schedule. This property is present only if the at least one Job
   * has run under the schedule.
   * @property {string} [recentJob.id]
   * @property {string} [recentJob.url]
   * @property {date} [endTime] The time at which the schedule ended. This
   * property is set only if the Job Schedule is in the completed state.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobScheduleExecutionInformation
   *
   * @returns {object} metadata of JobScheduleExecutionInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobScheduleExecutionInformation',
      type: {
        name: 'Composite',
        className: 'JobScheduleExecutionInformation',
        modelProperties: {
          nextRunTime: {
            required: false,
            serializedName: 'nextRunTime',
            type: {
              name: 'DateTime'
            }
          },
          recentJob: {
            required: false,
            serializedName: 'recentJob',
            type: {
              name: 'Composite',
              className: 'RecentJob'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = JobScheduleExecutionInformation;
