/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Properties used to create a user Account on a Windows Compute Node.
  *
 */
class WindowsUserConfiguration {
  /**
   * Create a WindowsUserConfiguration.
   * @property {string} [loginMode] The login mode for the user. The default
   * value for VirtualMachineConfiguration Pools is 'batch' and for
   * CloudServiceConfiguration Pools is 'interactive'. Possible values include:
   * 'batch', 'interactive'
   */
  constructor() {
  }

  /**
   * Defines the metadata of WindowsUserConfiguration
   *
   * @returns {object} metadata of WindowsUserConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WindowsUserConfiguration',
      type: {
        name: 'Composite',
        className: 'WindowsUserConfiguration',
        modelProperties: {
          loginMode: {
            required: false,
            serializedName: 'loginMode',
            type: {
              name: 'Enum',
              allowedValues: [ 'batch', 'interactive' ]
            }
          }
        }
      }
    };
  }
}

module.exports = WindowsUserConfiguration;
