/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details of volumes to mount on the cluster.
 *
 */
class MountVolumes {
  /**
   * Create a MountVolumes.
   * @member {array} [azureFileShares] Azure File Shares. A collection of Azure
   * File Shares that are to be mounted to the cluster nodes.
   * @member {array} [azureBlobFileSystems] Azure Blob file systems. A
   * collection of Azure Blob Containers that are to be mounted to the cluster
   * nodes.
   * @member {array} [fileServers] File Servers. A collection of Batch AI File
   * Servers that are to be mounted to the cluster nodes.
   * @member {array} [unmanagedFileSystems] Unmanaged file systems. A
   * collection of unmanaged file systems that are to be mounted to the cluster
   * nodes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MountVolumes
   *
   * @returns {object} metadata of MountVolumes
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MountVolumes',
      type: {
        name: 'Composite',
        className: 'MountVolumes',
        modelProperties: {
          azureFileShares: {
            required: false,
            serializedName: 'azureFileShares',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureFileShareReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureFileShareReference'
                  }
              }
            }
          },
          azureBlobFileSystems: {
            required: false,
            serializedName: 'azureBlobFileSystems',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AzureBlobFileSystemReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureBlobFileSystemReference'
                  }
              }
            }
          },
          fileServers: {
            required: false,
            serializedName: 'fileServers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'FileServerReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'FileServerReference'
                  }
              }
            }
          },
          unmanagedFileSystems: {
            required: false,
            serializedName: 'unmanagedFileSystems',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UnmanagedFileSystemReferenceElementType',
                  type: {
                    name: 'Composite',
                    className: 'UnmanagedFileSystemReference'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MountVolumes;
