/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Unmananged file system mounting configuration.
 *
 */
class UnmanagedFileSystemReference {
  /**
   * Create a UnmanagedFileSystemReference.
   * @member {string} mountCommand Mount command. Mount command line. Note,
   * Batch AI will append mount path to the command on its own.
   * @member {string} relativeMountPath Relative mount path. The relative path
   * on the compute node where the unmanaged file system will be mounted. Note
   * that all cluster level unmanaged file systems will be mounted under
   * $AZ_BATCHAI_MOUNT_ROOT location and all job level unmanaged file systems
   * will be mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UnmanagedFileSystemReference
   *
   * @returns {object} metadata of UnmanagedFileSystemReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UnmanagedFileSystemReference',
      type: {
        name: 'Composite',
        className: 'UnmanagedFileSystemReference',
        modelProperties: {
          mountCommand: {
            required: true,
            serializedName: 'mountCommand',
            type: {
              name: 'String'
            }
          },
          relativeMountPath: {
            required: true,
            serializedName: 'relativeMountPath',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UnmanagedFileSystemReference;
