/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Settings for user account that gets created on each on the nodes of a
 * cluster.
 *
 */
class UserAccountSettings {
  /**
   * Create a UserAccountSettings.
   * @member {string} adminUserName User name. Name of the administrator user
   * account which can be used to SSH to nodes.
   * @member {string} [adminUserSshPublicKey] SSH public key. SSH public key of
   * the administrator user account.
   * @member {string} [adminUserPassword] Password. Password of the
   * administrator user account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UserAccountSettings
   *
   * @returns {object} metadata of UserAccountSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserAccountSettings',
      type: {
        name: 'Composite',
        className: 'UserAccountSettings',
        modelProperties: {
          adminUserName: {
            required: true,
            serializedName: 'adminUserName',
            type: {
              name: 'String'
            }
          },
          adminUserSshPublicKey: {
            required: false,
            serializedName: 'adminUserSshPublicKey',
            type: {
              name: 'String'
            }
          },
          adminUserPassword: {
            required: false,
            serializedName: 'adminUserPassword',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UserAccountSettings;
