/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An enrollment account resource.
 *
 * @extends models['Resource']
 */
class EnrollmentAccount extends models['Resource'] {
  /**
   * Create a EnrollmentAccount.
   * @member {string} [principalName] The account owner's principal name.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EnrollmentAccount
   *
   * @returns {object} metadata of EnrollmentAccount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnrollmentAccount',
      type: {
        name: 'Composite',
        className: 'EnrollmentAccount',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          principalName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.principalName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EnrollmentAccount;
