/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines the identity of a resource.
 *
 * @extends models['ResponseBase']
 */
class Identifiable extends models['ResponseBase'] {
  /**
   * Create a Identifiable.
   * @property {string} [id] A String identifier.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Identifiable
   *
   * @returns {object} metadata of Identifiable
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Identifiable',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ResponseBase',
        className: 'Identifiable',
        modelProperties: {
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Identifiable;
