/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Refresh Index Response.
 *
 */
class RefreshIndex {
  /**
   * Create a RefreshIndex.
   * @property {string} [contentSourceId] Content source Id.
   * @property {boolean} [isUpdateSuccess] Update success status.
   * @property {array} [advancedInfo] Advanced info list.
   * @property {object} [status] Refresh index status.
   * @property {number} [status.code] Status code.
   * @property {string} [status.description] Status description.
   * @property {string} [status.exception] Exception status.
   * @property {string} [trackingId] Tracking Id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RefreshIndex
   *
   * @returns {object} metadata of RefreshIndex
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RefreshIndex',
      type: {
        name: 'Composite',
        className: 'RefreshIndex',
        modelProperties: {
          contentSourceId: {
            required: false,
            serializedName: 'ContentSourceId',
            type: {
              name: 'String'
            }
          },
          isUpdateSuccess: {
            required: false,
            serializedName: 'IsUpdateSuccess',
            type: {
              name: 'Boolean'
            }
          },
          advancedInfo: {
            required: false,
            serializedName: 'AdvancedInfo',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Dictionary',
                    value: {
                        required: false,
                        serializedName: 'StringElementType',
                        type: {
                          name: 'String'
                        }
                    }
                  }
              }
            }
          },
          status: {
            required: false,
            serializedName: 'Status',
            type: {
              name: 'Composite',
              className: 'Status'
            }
          },
          trackingId: {
            required: false,
            serializedName: 'TrackingId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RefreshIndex;
