/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Request body for applying snapshot operation.
 *
 */
class ApplySnapshotRequest {
  /**
   * Create a ApplySnapshotRequest.
   * @property {string} objectId User specified target object id to be created
   * from the snapshot.
   * @property {string} [mode] Snapshot applying mode. Currently only CreateNew
   * is supported, which means the apply operation will fail if target
   * subscription already contains an object of same type and using the same
   * objectId. Users can specify the "objectId" in request body to avoid such
   * conflicts. Possible values include: 'CreateNew'. Default value:
   * 'CreateNew' .
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplySnapshotRequest
   *
   * @returns {object} metadata of ApplySnapshotRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplySnapshotRequest',
      type: {
        name: 'Composite',
        className: 'ApplySnapshotRequest',
        modelProperties: {
          objectId: {
            required: true,
            serializedName: 'objectId',
            constraints: {
              MaxLength: 64,
              Pattern: /^[a-z0-9-_]+$/
            },
            type: {
              name: 'String'
            }
          },
          mode: {
            required: false,
            nullable: false,
            serializedName: 'mode',
            defaultValue: 'CreateNew',
            type: {
              name: 'Enum',
              allowedValues: [ 'CreateNew' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ApplySnapshotRequest;
