/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties describing any presence of blur within the image.
 *
 */
class Blur {
  /**
   * Create a Blur.
   * @property {string} [blurLevel] An enum value indicating level of
   * blurriness. Possible values include: 'Low', 'Medium', 'High'
   * @property {number} [value] A number indicating level of blurriness ranging
   * from 0 to 1.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Blur
   *
   * @returns {object} metadata of Blur
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Blur',
      type: {
        name: 'Composite',
        className: 'Blur',
        modelProperties: {
          blurLevel: {
            required: false,
            nullable: false,
            serializedName: 'blurLevel',
            type: {
              name: 'Enum',
              allowedValues: [ 'Low', 'Medium', 'High' ]
            }
          },
          value: {
            required: false,
            nullable: false,
            serializedName: 'value',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Blur;
