/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties describing facial emotion in form of confidence ranging from 0 to
 * 1.
 *
 */
class Emotion {
  /**
   * Create a Emotion.
   * @property {number} [anger]
   * @property {number} [contempt]
   * @property {number} [disgust]
   * @property {number} [fear]
   * @property {number} [happiness]
   * @property {number} [neutral]
   * @property {number} [sadness]
   * @property {number} [surprise]
   */
  constructor() {
  }

  /**
   * Defines the metadata of Emotion
   *
   * @returns {object} metadata of Emotion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Emotion',
      type: {
        name: 'Composite',
        className: 'Emotion',
        modelProperties: {
          anger: {
            required: false,
            nullable: false,
            serializedName: 'anger',
            type: {
              name: 'Number'
            }
          },
          contempt: {
            required: false,
            nullable: false,
            serializedName: 'contempt',
            type: {
              name: 'Number'
            }
          },
          disgust: {
            required: false,
            nullable: false,
            serializedName: 'disgust',
            type: {
              name: 'Number'
            }
          },
          fear: {
            required: false,
            nullable: false,
            serializedName: 'fear',
            type: {
              name: 'Number'
            }
          },
          happiness: {
            required: false,
            nullable: false,
            serializedName: 'happiness',
            type: {
              name: 'Number'
            }
          },
          neutral: {
            required: false,
            nullable: false,
            serializedName: 'neutral',
            type: {
              name: 'Number'
            }
          },
          sadness: {
            required: false,
            nullable: false,
            serializedName: 'sadness',
            type: {
              name: 'Number'
            }
          },
          surprise: {
            required: false,
            nullable: false,
            serializedName: 'surprise',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Emotion;
