/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A rectangle within which a face can be found
 *
 */
class FaceRectangle {
  /**
   * Create a FaceRectangle.
   * @property {number} width The width of the rectangle, in pixels.
   * @property {number} height The height of the rectangle, in pixels.
   * @property {number} left The distance from the left edge if the image to
   * the left edge of the rectangle, in pixels.
   * @property {number} top The distance from the top edge if the image to the
   * top edge of the rectangle, in pixels.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FaceRectangle
   *
   * @returns {object} metadata of FaceRectangle
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FaceRectangle',
      type: {
        name: 'Composite',
        className: 'FaceRectangle',
        modelProperties: {
          width: {
            required: true,
            serializedName: 'width',
            type: {
              name: 'Number'
            }
          },
          height: {
            required: true,
            serializedName: 'height',
            type: {
              name: 'Number'
            }
          },
          left: {
            required: true,
            serializedName: 'left',
            type: {
              name: 'Number'
            }
          },
          top: {
            required: true,
            serializedName: 'top',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = FaceRectangle;
