/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response body for identify face operation.
 *
 */
class IdentifyResult {
  /**
   * Create a IdentifyResult.
   * @property {uuid} faceId FaceId of the query face
   * @property {array} candidates Identified person candidates for that face
   * (ranked by confidence). Array size should be no larger than input
   * maxNumOfCandidatesReturned. If no person is identified, will return an
   * empty array.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IdentifyResult
   *
   * @returns {object} metadata of IdentifyResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IdentifyResult',
      type: {
        name: 'Composite',
        className: 'IdentifyResult',
        modelProperties: {
          faceId: {
            required: true,
            serializedName: 'faceId',
            type: {
              name: 'String'
            }
          },
          candidates: {
            required: true,
            serializedName: 'candidates',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IdentifyCandidateElementType',
                  type: {
                    name: 'Composite',
                    className: 'IdentifyCandidate'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = IdentifyResult;
