/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A combination of user defined name and user specified data for the person,
 * largePersonGroup/personGroup, and largeFaceList/faceList.
 *
 */
class NameAndUserDataContract {
  /**
   * Create a NameAndUserDataContract.
   * @property {string} [name] User defined name, maximum length is 128.
   * @property {string} [userData] User specified data. Length should not
   * exceed 16KB.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NameAndUserDataContract
   *
   * @returns {object} metadata of NameAndUserDataContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NameAndUserDataContract',
      type: {
        name: 'Composite',
        className: 'NameAndUserDataContract',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            constraints: {
              MaxLength: 128
            },
            type: {
              name: 'String'
            }
          },
          userData: {
            required: false,
            serializedName: 'userData',
            constraints: {
              MaxLength: 16384
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NameAndUserDataContract;
