/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of AreaOfInterest operation.
 *
 */
class AreaOfInterestResult {
  /**
   * Create a AreaOfInterestResult.
   * @property {object} [areaOfInterest] A bounding box for an area of interest
   * inside an image.
   * @property {number} [areaOfInterest.x] X-coordinate of the top left point
   * of the area, in pixels.
   * @property {number} [areaOfInterest.y] Y-coordinate of the top left point
   * of the area, in pixels.
   * @property {number} [areaOfInterest.w] Width measured from the top-left
   * point of the area, in pixels.
   * @property {number} [areaOfInterest.h] Height measured from the top-left
   * point of the area, in pixels.
   * @property {string} [requestId] Id of the REST API request.
   * @property {object} [metadata]
   * @property {number} [metadata.width] Image width, in pixels.
   * @property {number} [metadata.height] Image height, in pixels.
   * @property {string} [metadata.format] Image format.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AreaOfInterestResult
   *
   * @returns {object} metadata of AreaOfInterestResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AreaOfInterestResult',
      type: {
        name: 'Composite',
        className: 'AreaOfInterestResult',
        modelProperties: {
          areaOfInterest: {
            required: false,
            readOnly: true,
            serializedName: 'areaOfInterest',
            type: {
              name: 'Composite',
              className: 'BoundingRect'
            }
          },
          requestId: {
            required: false,
            nullable: true,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Composite',
              className: 'ImageMetadata'
            }
          }
        }
      }
    };
  }
}

module.exports = AreaOfInterestResult;
