/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of domain-specific classifications for the domain of celebrities.
 *
 */
class CelebrityResults {
  /**
   * Create a CelebrityResults.
   * @property {array} [celebrities] List of celebrities recognized in the
   * image.
   * @property {string} [requestId] Id of the REST API request.
   * @property {object} [metadata]
   * @property {number} [metadata.width] Image width, in pixels.
   * @property {number} [metadata.height] Image height, in pixels.
   * @property {string} [metadata.format] Image format.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CelebrityResults
   *
   * @returns {object} metadata of CelebrityResults
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CelebrityResults',
      type: {
        name: 'Composite',
        className: 'CelebrityResults',
        modelProperties: {
          celebrities: {
            required: false,
            nullable: true,
            serializedName: 'celebrities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CelebritiesModelElementType',
                  type: {
                    name: 'Composite',
                    className: 'CelebritiesModel'
                  }
              }
            }
          },
          requestId: {
            required: false,
            nullable: true,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Composite',
              className: 'ImageMetadata'
            }
          }
        }
      }
    };
  }
}

module.exports = CelebrityResults;
