/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details about the API request error.
 *
 */
class ComputerVisionError {
  /**
   * Create a ComputerVisionError.
   * @property {object} code The error code.
   * @property {string} message A message explaining the error reported by the
   * service.
   * @property {string} [requestId] A unique request identifier.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ComputerVisionError
   *
   * @returns {object} metadata of ComputerVisionError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ComputerVisionError',
      type: {
        name: 'Composite',
        className: 'ComputerVisionError',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'Object'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          requestId: {
            required: false,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ComputerVisionError;
