/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A landmark recognized in the image.
 *
 */
class LandmarksModel {
  /**
   * Create a LandmarksModel.
   * @property {string} [name] Name of the landmark.
   * @property {number} [confidence] Confidence level for the landmark
   * recognition as a value ranging from 0 to 1.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LandmarksModel
   *
   * @returns {object} metadata of LandmarksModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LandmarksModel',
      type: {
        name: 'Composite',
        className: 'LandmarksModel',
        modelProperties: {
          name: {
            required: false,
            nullable: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          confidence: {
            required: false,
            nullable: false,
            serializedName: 'confidence',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = LandmarksModel;
