/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A charge summary resource.
 *
 * @extends models['Resource']
 */
class ChargeSummary extends models['Resource'] {
  /**
   * Create a ChargeSummary.
   * @member {string} [billingPeriodId] The id of the billing period resource
   * that the charge belongs to.
   * @member {string} [usageStart] Usage start date.
   * @member {string} [usageEnd] Usage end date.
   * @member {number} [azureCharges] Azure Charges.
   * @member {number} [chargesBilledSeparately] Charges Billed separately.
   * @member {number} [marketplaceCharges] Marketplace Charges.
   * @member {string} [currency] Currency Code
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ChargeSummary
   *
   * @returns {object} metadata of ChargeSummary
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ChargeSummary',
      type: {
        name: 'Composite',
        className: 'ChargeSummary',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          billingPeriodId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.billingPeriodId',
            type: {
              name: 'String'
            }
          },
          usageStart: {
            required: false,
            readOnly: true,
            serializedName: 'properties.usageStart',
            type: {
              name: 'String'
            }
          },
          usageEnd: {
            required: false,
            readOnly: true,
            serializedName: 'properties.usageEnd',
            type: {
              name: 'String'
            }
          },
          azureCharges: {
            required: false,
            readOnly: true,
            serializedName: 'properties.azureCharges',
            type: {
              name: 'Number'
            }
          },
          chargesBilledSeparately: {
            required: false,
            readOnly: true,
            serializedName: 'properties.chargesBilledSeparately',
            type: {
              name: 'Number'
            }
          },
          marketplaceCharges: {
            required: false,
            readOnly: true,
            serializedName: 'properties.marketplaceCharges',
            type: {
              name: 'Number'
            }
          },
          currency: {
            required: false,
            readOnly: true,
            serializedName: 'properties.currency',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ChargeSummary;
