/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Reservation recommendations resource.
 *
 */
class ReservationRecommendations {
  /**
   * Create a ReservationRecommendations.
   * @member {string} [id] Resource Id.
   * @member {string} [name] Resource name.
   * @member {string} [type] Resource type.
   * @member {object} [tags] Resource tags.
   * @member {string} [location] Resource location
   * @member {string} [sku] Resource sku
   * @member {string} [lookBackPeriod] The number of days of usage to look back
   * for recommendations.
   * @member {uuid} [meterId] The meter id (GUID)
   * @member {string} [term] RI recommendations in one or three year terms.
   * @member {number} [costWithNoReservedInstances] The total amount of cost
   * without reserved instances.
   * @member {number} [recommendedQuantity] Recomended quality for reserved
   * instances.
   * @member {number} [totalCostWithReservedInstances] The total amount of cost
   * with reserved instances.
   * @member {number} [netSavings] Total estimated savings with reserved
   * instances.
   * @member {date} [firstUsageDate] The usage date for looking back.
   * @member {string} [scope] Shared or single recommendation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReservationRecommendations
   *
   * @returns {object} metadata of ReservationRecommendations
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReservationRecommendations',
      type: {
        name: 'Composite',
        className: 'ReservationRecommendations',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            readOnly: true,
            serializedName: 'sku',
            type: {
              name: 'String'
            }
          },
          lookBackPeriod: {
            required: false,
            readOnly: true,
            serializedName: 'properties.lookBackPeriod',
            type: {
              name: 'String'
            }
          },
          meterId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.meterId',
            type: {
              name: 'String'
            }
          },
          term: {
            required: false,
            readOnly: true,
            serializedName: 'properties.term',
            type: {
              name: 'String'
            }
          },
          costWithNoReservedInstances: {
            required: false,
            readOnly: true,
            serializedName: 'properties.costWithNoReservedInstances',
            type: {
              name: 'Number'
            }
          },
          recommendedQuantity: {
            required: false,
            readOnly: true,
            serializedName: 'properties.recommendedQuantity',
            type: {
              name: 'Number'
            }
          },
          totalCostWithReservedInstances: {
            required: false,
            readOnly: true,
            serializedName: 'properties.totalCostWithReservedInstances',
            type: {
              name: 'Number'
            }
          },
          netSavings: {
            required: false,
            readOnly: true,
            serializedName: 'properties.netSavings',
            type: {
              name: 'Number'
            }
          },
          firstUsageDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.firstUsageDate',
            type: {
              name: 'DateTime'
            }
          },
          scope: {
            required: false,
            readOnly: true,
            serializedName: 'properties.scope',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReservationRecommendations;
