/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties that are enabled for Odata querying.
 *
 */
class BuildFilter {
  /**
   * Create a BuildFilter.
   * @member {string} [buildId] The unique identifier for the build.
   * @member {string} [buildType] The type of build. Possible values include:
   * 'AutoBuild', 'QuickBuild'
   * @member {string} [status] The current status of the build. Possible values
   * include: 'Queued', 'Started', 'Running', 'Succeeded', 'Failed',
   * 'Canceled', 'Error', 'Timeout'
   * @member {date} [createTime] The create time for a build.
   * @member {date} [finishTime] The time the build finished.
   * @member {string} [outputImageManifests] The list of comma-separated image
   * manifests that were generated from the build.
   * @member {boolean} [isArchiveEnabled] The value that indicates whether
   * archiving is enabled or not.
   * @member {string} [buildTaskName] The name of the build task that the build
   * corresponds to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BuildFilter
   *
   * @returns {object} metadata of BuildFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BuildFilter',
      type: {
        name: 'Composite',
        className: 'BuildFilter',
        modelProperties: {
          buildId: {
            required: false,
            serializedName: 'buildId',
            type: {
              name: 'String'
            }
          },
          buildType: {
            required: false,
            serializedName: 'buildType',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          createTime: {
            required: false,
            serializedName: 'createTime',
            type: {
              name: 'DateTime'
            }
          },
          finishTime: {
            required: false,
            serializedName: 'finishTime',
            type: {
              name: 'DateTime'
            }
          },
          outputImageManifests: {
            required: false,
            serializedName: 'outputImageManifests',
            type: {
              name: 'String'
            }
          },
          isArchiveEnabled: {
            required: false,
            serializedName: 'isArchiveEnabled',
            type: {
              name: 'Boolean'
            }
          },
          buildTaskName: {
            required: false,
            serializedName: 'buildTaskName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BuildFilter;
