/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties for updating a docker build step.
 *
 * @extends models['TaskStepUpdateParameters']
 */
class DockerBuildStepUpdateParameters extends models['TaskStepUpdateParameters'] {
  /**
   * Create a DockerBuildStepUpdateParameters.
   * @property {array} [imageNames] The fully qualified image names including
   * the repository and tag.
   * @property {boolean} [isPushEnabled] The value of this property indicates
   * whether the image built should be pushed to the registry or not.
   * @property {boolean} [noCache] The value of this property indicates whether
   * the image cache is enabled or not.
   * @property {string} [dockerFilePath] The Docker file path relative to the
   * source context.
   * @property {array} [argumentsProperty] The collection of override arguments
   * to be used when executing this build step.
   * @property {string} [target] The name of the target build stage for the
   * docker build.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DockerBuildStepUpdateParameters
   *
   * @returns {object} metadata of DockerBuildStepUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Docker',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'TaskStepUpdateParameters',
        className: 'DockerBuildStepUpdateParameters',
        modelProperties: {
          contextPath: {
            required: false,
            serializedName: 'contextPath',
            type: {
              name: 'String'
            }
          },
          contextAccessToken: {
            required: false,
            serializedName: 'contextAccessToken',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          imageNames: {
            required: false,
            serializedName: 'imageNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          isPushEnabled: {
            required: false,
            serializedName: 'isPushEnabled',
            type: {
              name: 'Boolean'
            }
          },
          noCache: {
            required: false,
            serializedName: 'noCache',
            type: {
              name: 'Boolean'
            }
          },
          dockerFilePath: {
            required: false,
            serializedName: 'dockerFilePath',
            type: {
              name: 'String'
            }
          },
          argumentsProperty: {
            required: false,
            serializedName: 'arguments',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ArgumentElementType',
                  type: {
                    name: 'Composite',
                    className: 'Argument'
                  }
              }
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DockerBuildStepUpdateParameters;
