/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response from the ListCredentials operation.
 *
 */
class RegistryListCredentialsResult {
  /**
   * Create a RegistryListCredentialsResult.
   * @property {string} [username] The username for a container registry.
   * @property {array} [passwords] The list of passwords for a container
   * registry.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegistryListCredentialsResult
   *
   * @returns {object} metadata of RegistryListCredentialsResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegistryListCredentialsResult',
      type: {
        name: 'Composite',
        className: 'RegistryListCredentialsResult',
        modelProperties: {
          username: {
            required: false,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          passwords: {
            required: false,
            serializedName: 'passwords',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RegistryPasswordElementType',
                  type: {
                    name: 'Composite',
                    className: 'RegistryPassword'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RegistryListCredentialsResult;
