/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the properties of a secret object value.
 *
 */
class SecretObject {
  /**
   * Create a SecretObject.
   * @property {string} [value] The value of the secret. The format of this
   * value will be determined
   * based on the type of the secret object. If the type is Opaque, the value
   * will be
   * used as is without any modification.
   * @property {string} [type] The type of the secret object which determines
   * how the value of the secret object has to be
   * interpreted. Possible values include: 'Opaque', 'Vaultsecret'
   */
  constructor() {
  }

  /**
   * Defines the metadata of SecretObject
   *
   * @returns {object} metadata of SecretObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecretObject',
      type: {
        name: 'Composite',
        className: 'SecretObject',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecretObject;
