/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the credential parameters for accessing the source registry.
 *
 */
class SourceRegistryCredentials {
  /**
   * Create a SourceRegistryCredentials.
   * @property {string} [loginMode] The authentication mode which determines
   * the source registry login scope. The credentials for the source registry
   * will be generated using the given scope. These credentials will be used to
   * login to
   * the source registry during the run. Possible values include: 'None',
   * 'Default'
   */
  constructor() {
  }

  /**
   * Defines the metadata of SourceRegistryCredentials
   *
   * @returns {object} metadata of SourceRegistryCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SourceRegistryCredentials',
      type: {
        name: 'Composite',
        className: 'SourceRegistryCredentials',
        modelProperties: {
          loginMode: {
            required: false,
            serializedName: 'loginMode',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SourceRegistryCredentials;
