/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Base properties for updating any task step.
 *
 */
class TaskStepUpdateParameters {
  /**
   * Create a TaskStepUpdateParameters.
   * @property {string} [contextPath] The URL(absolute or relative) of the
   * source context for the task step.
   * @property {string} [contextAccessToken] The token (git PAT or SAS token of
   * storage account blob) associated with the context for a step.
   * @property {string} type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of TaskStepUpdateParameters
   *
   * @returns {object} metadata of TaskStepUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskStepUpdateParameters',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'TaskStepUpdateParameters',
        className: 'TaskStepUpdateParameters',
        modelProperties: {
          contextPath: {
            required: false,
            serializedName: 'contextPath',
            type: {
              name: 'String'
            }
          },
          contextAccessToken: {
            required: false,
            serializedName: 'contextAccessToken',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TaskStepUpdateParameters;
