/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of a timer trigger.
 *
 */
class TimerTrigger {
  /**
   * Create a TimerTrigger.
   * @property {string} schedule The CRON expression for the task schedule
   * @property {string} [status] The current status of trigger. Possible values
   * include: 'Disabled', 'Enabled'. Default value: 'Enabled' .
   * @property {string} name The name of the trigger.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TimerTrigger
   *
   * @returns {object} metadata of TimerTrigger
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TimerTrigger',
      type: {
        name: 'Composite',
        className: 'TimerTrigger',
        modelProperties: {
          schedule: {
            required: true,
            serializedName: 'schedule',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            defaultValue: 'Enabled',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TimerTrigger;
