/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object that represents content trust policy for a container registry.
 *
 */
class TrustPolicy {
  /**
   * Create a TrustPolicy.
   * @property {string} [type] The type of trust policy. Possible values
   * include: 'Notary'
   * @property {string} [status] The value that indicates whether the policy is
   * enabled or not. Possible values include: 'enabled', 'disabled'
   */
  constructor() {
  }

  /**
   * Defines the metadata of TrustPolicy
   *
   * @returns {object} metadata of TrustPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrustPolicy',
      type: {
        name: 'Composite',
        className: 'TrustPolicy',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TrustPolicy;
