/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The container exec request.
 *
 */
class ContainerExecRequest {
  /**
   * Create a ContainerExecRequest.
   * @member {string} [command] The command to be executed.
   * @member {object} [terminalSize] The size of the terminal.
   * @member {number} [terminalSize.rows] The row size of the terminal
   * @member {number} [terminalSize.cols] The column size of the terminal
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerExecRequest
   *
   * @returns {object} metadata of ContainerExecRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerExecRequest',
      type: {
        name: 'Composite',
        className: 'ContainerExecRequest',
        modelProperties: {
          command: {
            required: false,
            serializedName: 'command',
            type: {
              name: 'String'
            }
          },
          terminalSize: {
            required: false,
            serializedName: 'terminalSize',
            type: {
              name: 'Composite',
              className: 'ContainerExecRequestTerminalSize'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerExecRequest;
