/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * IP address for the container group.
 *
 */
class IpAddress {
  /**
   * Create a IpAddress.
   * @member {array} ports The list of ports exposed on the container group.
   * @member {string} type Specifies if the IP is exposed to the public
   * internet or private VNET. Possible values include: 'Public', 'Private'
   * @member {string} [ip] The IP exposed to the public internet.
   * @member {string} [dnsNameLabel] The Dns name label for the IP.
   * @member {string} [fqdn] The FQDN for the IP.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IpAddress
   *
   * @returns {object} metadata of IpAddress
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IpAddress',
      type: {
        name: 'Composite',
        className: 'IpAddress',
        modelProperties: {
          ports: {
            required: true,
            serializedName: 'ports',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PortElementType',
                  type: {
                    name: 'Composite',
                    className: 'Port'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          ip: {
            required: false,
            serializedName: 'ip',
            type: {
              name: 'String'
            }
          },
          dnsNameLabel: {
            required: false,
            serializedName: 'dnsNameLabel',
            type: {
              name: 'String'
            }
          },
          fqdn: {
            required: false,
            readOnly: true,
            serializedName: 'fqdn',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IpAddress;
