/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The operation list response that contains all operations for Azure Container
 * Instance service.
 *
 */
class OperationListResult {
  /**
   * Create a OperationListResult.
   * @member {array} [value] The list of operations.
   * @member {string} [nextLink] The URI to fetch the next page of operations.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationListResult
   *
   * @returns {object} metadata of OperationListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationListResult',
      type: {
        name: 'Composite',
        className: 'OperationListResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OperationElementType',
                  type: {
                    name: 'Composite',
                    className: 'Operation'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationListResult;
