/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A Kubernetes add-on profile for a managed cluster.
 *
 */
class ManagedClusterAddonProfile {
  /**
   * Create a ManagedClusterAddonProfile.
   * @property {boolean} enabled Whether the add-on is enabled or not.
   * @property {object} [config] Key-value pairs for configuring an add-on.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagedClusterAddonProfile
   *
   * @returns {object} metadata of ManagedClusterAddonProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedClusterAddonProfile',
      type: {
        name: 'Composite',
        className: 'ManagedClusterAddonProfile',
        modelProperties: {
          enabled: {
            required: true,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          config: {
            required: false,
            serializedName: 'config',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedClusterAddonProfile;
