/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the configuration of the identity providers to be used in the
 * OpenShift cluster.
 *
 */
class OpenShiftManagedClusterIdentityProvider {
  /**
   * Create a OpenShiftManagedClusterIdentityProvider.
   * @property {string} [name] Name of the provider.
   * @property {object} [provider] Configuration of the provider.
   * @property {string} [provider.kind] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of OpenShiftManagedClusterIdentityProvider
   *
   * @returns {object} metadata of OpenShiftManagedClusterIdentityProvider
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OpenShiftManagedClusterIdentityProvider',
      type: {
        name: 'Composite',
        className: 'OpenShiftManagedClusterIdentityProvider',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'kind',
                clientName: 'kind'
              },
              uberParent: 'OpenShiftManagedClusterBaseIdentityProvider',
              className: 'OpenShiftManagedClusterBaseIdentityProvider'
            }
          }
        }
      }
    };
  }
}

module.exports = OpenShiftManagedClusterIdentityProvider;
