/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Reference to another subresource.
 *
 * @extends models['BaseResource']
 */
class SubResource extends models['BaseResource'] {
  /**
   * Create a SubResource.
   * @property {string} [id] Resource ID.
   * @property {string} [name] The name of the resource that is unique within a
   * resource group. This name can be used to access the resource.
   * @property {string} [type] Resource type
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SubResource
   *
   * @returns {object} metadata of SubResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubResource',
      type: {
        name: 'Composite',
        className: 'SubResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SubResource;
