/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents performance data for a particular tag in a trained iteration.
 *
 */
class TagPerformance {
  /**
   * Create a TagPerformance.
   * @property {uuid} [id]
   * @property {string} [name]
   * @property {number} [precision] Gets the precision.
   * @property {number} [precisionStdDeviation] Gets the standard deviation for
   * the precision.
   * @property {number} [recall] Gets the recall.
   * @property {number} [recallStdDeviation] Gets the standard deviation for
   * the recall.
   * @property {number} [averagePrecision] Gets the average precision when
   * applicable.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TagPerformance
   *
   * @returns {object} metadata of TagPerformance
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TagPerformance',
      type: {
        name: 'Composite',
        className: 'TagPerformance',
        modelProperties: {
          id: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          precision: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'precision',
            type: {
              name: 'Number'
            }
          },
          precisionStdDeviation: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'precisionStdDeviation',
            type: {
              name: 'Number'
            }
          },
          recall: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'recall',
            type: {
              name: 'Number'
            }
          },
          recallStdDeviation: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'recallStdDeviation',
            type: {
              name: 'Number'
            }
          },
          averagePrecision: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'averagePrecision',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = TagPerformance;
