/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Copy Log Details for a disk
 *
 * @extends models['CopyLogDetails']
 */
class DataBoxDiskCopyLogDetails extends models['CopyLogDetails'] {
  /**
   * Create a DataBoxDiskCopyLogDetails.
   * @member {string} [diskSerialNumber] Disk Serial Number.
   * @member {string} [errorLogLink] Link for copy error logs.
   * @member {string} [verboseLogLink] Link for copy verbose logs.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DataBoxDiskCopyLogDetails
   *
   * @returns {object} metadata of DataBoxDiskCopyLogDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataBoxDisk',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'copyLogDetailsType',
          clientName: 'copyLogDetailsType'
        },
        uberParent: 'CopyLogDetails',
        className: 'DataBoxDiskCopyLogDetails',
        modelProperties: {
          copyLogDetailsType: {
            required: true,
            serializedName: 'copyLogDetailsType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          diskSerialNumber: {
            required: false,
            readOnly: true,
            serializedName: 'diskSerialNumber',
            type: {
              name: 'String'
            }
          },
          errorLogLink: {
            required: false,
            readOnly: true,
            serializedName: 'errorLogLink',
            type: {
              name: 'String'
            }
          },
          verboseLogLink: {
            required: false,
            readOnly: true,
            serializedName: 'verboseLogLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DataBoxDiskCopyLogDetails;
