/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The secrets related to disk job.
 *
 * @extends models['JobSecrets']
 */
class DataBoxDiskJobSecrets extends models['JobSecrets'] {
  /**
   * Create a DataBoxDiskJobSecrets.
   * @member {array} [diskSecrets] Contains the list of secrets object for that
   * device.
   * @member {string} [passKey] PassKey for the disk Job.
   * @member {boolean} [isPasskeyUserDefined] Whether passkey was provided by
   * user.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DataBoxDiskJobSecrets
   *
   * @returns {object} metadata of DataBoxDiskJobSecrets
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataBoxDisk',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'jobSecretsType',
          clientName: 'jobSecretsType'
        },
        uberParent: 'JobSecrets',
        className: 'DataBoxDiskJobSecrets',
        modelProperties: {
          jobSecretsType: {
            required: true,
            serializedName: 'jobSecretsType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          diskSecrets: {
            required: false,
            readOnly: true,
            serializedName: 'diskSecrets',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DiskSecretElementType',
                  type: {
                    name: 'Composite',
                    className: 'DiskSecret'
                  }
              }
            }
          },
          passKey: {
            required: false,
            readOnly: true,
            serializedName: 'passKey',
            type: {
              name: 'String'
            }
          },
          isPasskeyUserDefined: {
            required: false,
            readOnly: true,
            serializedName: 'isPasskeyUserDefined',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DataBoxDiskJobSecrets;
