/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The secrets related to a databox heavy job.
 *
 * @extends models['JobSecrets']
 */
class DataBoxHeavyJobSecrets extends models['JobSecrets'] {
  /**
   * Create a DataBoxHeavyJobSecrets.
   * @member {array} [cabinetPodSecrets] Contains the list of secret objects
   * for a databox heavy job.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DataBoxHeavyJobSecrets
   *
   * @returns {object} metadata of DataBoxHeavyJobSecrets
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataBoxHeavy',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'jobSecretsType',
          clientName: 'jobSecretsType'
        },
        uberParent: 'JobSecrets',
        className: 'DataBoxHeavyJobSecrets',
        modelProperties: {
          jobSecretsType: {
            required: true,
            serializedName: 'jobSecretsType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          cabinetPodSecrets: {
            required: false,
            readOnly: true,
            serializedName: 'cabinetPodSecrets',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DataBoxHeavySecretElementType',
                  type: {
                    name: 'Composite',
                    className: 'DataBoxHeavySecret'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DataBoxHeavyJobSecrets;
