/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Notification preference for a job stage.
 *
 */
class NotificationPreference {
  /**
   * Create a NotificationPreference.
   * @member {string} stageName Name of the stage. Possible values include:
   * 'DevicePrepared', 'Dispatched', 'Delivered', 'PickedUp', 'AtAzureDC',
   * 'DataCopy'
   * @member {boolean} sendNotification Notification is required or not.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NotificationPreference
   *
   * @returns {object} metadata of NotificationPreference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NotificationPreference',
      type: {
        name: 'Composite',
        className: 'NotificationPreference',
        modelProperties: {
          stageName: {
            required: true,
            serializedName: 'stageName',
            type: {
              name: 'Enum',
              allowedValues: [ 'DevicePrepared', 'Dispatched', 'Delivered', 'PickedUp', 'AtAzureDC', 'DataCopy' ]
            }
          },
          sendNotification: {
            required: true,
            serializedName: 'sendNotification',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = NotificationPreference;
