/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * List of service health response.
 *
 */
class ServiceHealthResponseList {
  /**
   * Create a ServiceHealthResponseList.
   * @member {array} [dependencies] List of ServiceHealthResponse.
   * @member {string} [serviceVersion] Version of the service.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceHealthResponseList
   *
   * @returns {object} metadata of ServiceHealthResponseList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceHealthResponseList',
      type: {
        name: 'Composite',
        className: 'ServiceHealthResponseList',
        modelProperties: {
          dependencies: {
            required: false,
            serializedName: 'dependencies',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServiceHealthResponseElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServiceHealthResponse'
                  }
              }
            }
          },
          serviceVersion: {
            required: false,
            serializedName: 'serviceVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceHealthResponseList;
