/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Shipment pick up request details.
 *
 */
class ShipmentPickUpRequest {
  /**
   * Create a ShipmentPickUpRequest.
   * @member {date} startTime Minimum date after which the pick up should
   * commence, this must be in local time of pick up area.
   * @member {date} endTime Maximum date before which the pick up should
   * commence, this must be in local time of pick up area.
   * @member {string} shipmentLocation Shipment Location in the pickup place.
   * Eg.front desk
   */
  constructor() {
  }

  /**
   * Defines the metadata of ShipmentPickUpRequest
   *
   * @returns {object} metadata of ShipmentPickUpRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ShipmentPickUpRequest',
      type: {
        name: 'Composite',
        className: 'ShipmentPickUpRequest',
        modelProperties: {
          startTime: {
            required: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          shipmentLocation: {
            required: true,
            serializedName: 'shipmentLocation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ShipmentPickUpRequest;
