/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Unencrypted credentials for accessing device.
 *
 */
class UnencryptedCredentials {
  /**
   * Create a UnencryptedCredentials.
   * @member {string} [jobName] Name of the job.
   * @member {object} [jobSecrets] Secrets related to this job.
   * @member {string} [jobSecrets.jobSecretsType] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of UnencryptedCredentials
   *
   * @returns {object} metadata of UnencryptedCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UnencryptedCredentials',
      type: {
        name: 'Composite',
        className: 'UnencryptedCredentials',
        modelProperties: {
          jobName: {
            required: false,
            readOnly: true,
            serializedName: 'jobName',
            type: {
              name: 'String'
            }
          },
          jobSecrets: {
            required: false,
            readOnly: true,
            serializedName: 'jobSecrets',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'jobSecretsType',
                clientName: 'jobSecretsType'
              },
              uberParent: 'JobSecrets',
              className: 'JobSecrets'
            }
          }
        }
      }
    };
  }
}

module.exports = UnencryptedCredentials;
