/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Integration runtime status.
 *
 */
class IntegrationRuntimeStatus {
  /**
   * Create a IntegrationRuntimeStatus.
   * @member {string} [dataFactoryName] The data factory name which the
   * integration runtime belong to.
   * @member {string} [state] The state of integration runtime. Possible values
   * include: 'Initial', 'Stopped', 'Started', 'Starting', 'Stopping',
   * 'NeedRegistration', 'Online', 'Limited', 'Offline', 'AccessDenied'
   * @member {string} type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of IntegrationRuntimeStatus
   *
   * @returns {object} metadata of IntegrationRuntimeStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IntegrationRuntimeStatus',
      type: {
        name: 'Composite',
        additionalProperties: {
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'ObjectElementType',
                type: {
                  name: 'Object'
                }
            }
          }
        },
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'IntegrationRuntimeStatus',
        className: 'IntegrationRuntimeStatus',
        modelProperties: {
          dataFactoryName: {
            required: false,
            readOnly: true,
            serializedName: 'dataFactoryName',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            readOnly: true,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IntegrationRuntimeStatus;
