/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The key authorization type integration runtime.
 *
 * @extends models['LinkedIntegrationRuntimeType']
 */
class LinkedIntegrationRuntimeKeyAuthorization extends models['LinkedIntegrationRuntimeType'] {
  /**
   * Create a LinkedIntegrationRuntimeKeyAuthorization.
   * @member {object} key The key used for authorization.
   * @member {string} [key.value] Value of secure string.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LinkedIntegrationRuntimeKeyAuthorization
   *
   * @returns {object} metadata of LinkedIntegrationRuntimeKeyAuthorization
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Key',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'authorizationType',
          clientName: 'authorizationType'
        },
        uberParent: 'LinkedIntegrationRuntimeType',
        className: 'LinkedIntegrationRuntimeKeyAuthorization',
        modelProperties: {
          authorizationType: {
            required: true,
            serializedName: 'authorizationType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          key: {
            required: true,
            serializedName: 'key',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'SecretBase',
              className: 'SecureString'
            }
          }
        }
      }
    };
  }
}

module.exports = LinkedIntegrationRuntimeKeyAuthorization;
