/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Update integration runtime request.
 *
 */
class UpdateIntegrationRuntimeRequest {
  /**
   * Create a UpdateIntegrationRuntimeRequest.
   * @member {string} [autoUpdate] Enables or disables the auto-update feature
   * of the self-hosted integration runtime. See
   * https://go.microsoft.com/fwlink/?linkid=854189. Possible values include:
   * 'On', 'Off'
   * @member {string} [updateDelayOffset] The time offset (in hours) in the
   * day, e.g., PT03H is 3 hours. The integration runtime auto update will
   * happen on that time.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateIntegrationRuntimeRequest
   *
   * @returns {object} metadata of UpdateIntegrationRuntimeRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateIntegrationRuntimeRequest',
      type: {
        name: 'Composite',
        className: 'UpdateIntegrationRuntimeRequest',
        modelProperties: {
          autoUpdate: {
            required: false,
            serializedName: 'autoUpdate',
            type: {
              name: 'String'
            }
          },
          updateDelayOffset: {
            required: false,
            serializedName: 'updateDelayOffset',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateIntegrationRuntimeRequest;
