/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents an operation that can be performed on the service.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] The name of the operation.
   * @member {object} [display] The display name of the operation.
   * @member {string} [display.provider] The name of the provider that supports
   * the operation.
   * @member {string} [display.resource] The resource type on which this
   * operation can be performed.
   * @member {string} [display.operation] The name of the operation.
   * @member {string} [display.description] The description of the operation.
   * @member {string} [origin] The origin of the operation.
   * @member {object} [properties] The properties of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDetail'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
