/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The resource representation of a service in a service topology.
 *
 * @extends models['TrackedResource']
 */
class ServiceResource extends models['TrackedResource'] {
  /**
   * Create a ServiceResource.
   * @member {string} targetLocation The Azure location to which the resources
   * in the service belong to or should be deployed to.
   * @member {string} targetSubscriptionId The subscription to which the
   * resources in the service belong to or should be deployed to.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceResource
   *
   * @returns {object} metadata of ServiceResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceResource',
      type: {
        name: 'Composite',
        className: 'ServiceResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          targetLocation: {
            required: true,
            serializedName: 'properties.targetLocation',
            type: {
              name: 'String'
            }
          },
          targetSubscriptionId: {
            required: true,
            serializedName: 'properties.targetSubscriptionId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceResource;
