/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines the properties of a Wait step.
 *
 * @extends models['StepProperties']
 */
class WaitStepProperties extends models['StepProperties'] {
  /**
   * Create a WaitStepProperties.
   * @member {object} [attributes] The Wait attributes
   * @member {string} [attributes.duration] The duration in ISO 8601 format of
   * how long the wait should be.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WaitStepProperties
   *
   * @returns {object} metadata of WaitStepProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Wait',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'stepType',
          clientName: 'stepType'
        },
        uberParent: 'StepProperties',
        className: 'WaitStepProperties',
        modelProperties: {
          stepType: {
            required: true,
            serializedName: 'stepType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          attributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'WaitStepAttributes'
            }
          }
        }
      }
    };
  }
}

module.exports = WaitStepProperties;
