/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a managed identity
 *
 */
class IdentityProperties {
  /**
   * Create a IdentityProperties.
   * @property {string} [type] Managed identity.
   * @property {string} [principalId] The principal id of resource identity.
   * @property {string} [tenantId] The tenant identifier of resource.
   * @property {string} [clientSecretUrl] The client secret URL of the
   * identity.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IdentityProperties
   *
   * @returns {object} metadata of IdentityProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IdentityProperties',
      type: {
        name: 'Composite',
        className: 'IdentityProperties',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          principalId: {
            required: false,
            serializedName: 'principalId',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          clientSecretUrl: {
            required: false,
            serializedName: 'clientSecretUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IdentityProperties;
