/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.WeekDetails = require('./weekDetails');
exports.DayDetails = require('./dayDetails');
exports.HourDetails = require('./hourDetails');
exports.NotificationSettings = require('./notificationSettings');
exports.Resource = require('./resource');
exports.Schedule = require('./schedule');
exports.ApplicableSchedule = require('./applicableSchedule');
exports.WeekDetailsFragment = require('./weekDetailsFragment');
exports.DayDetailsFragment = require('./dayDetailsFragment');
exports.HourDetailsFragment = require('./hourDetailsFragment');
exports.NotificationSettingsFragment = require('./notificationSettingsFragment');
exports.UpdateResource = require('./updateResource');
exports.ScheduleFragment = require('./scheduleFragment');
exports.ApplicableScheduleFragment = require('./applicableScheduleFragment');
exports.ArtifactParameterProperties = require('./artifactParameterProperties');
exports.ArtifactInstallProperties = require('./artifactInstallProperties');
exports.ApplyArtifactsRequest = require('./applyArtifactsRequest');
exports.ParametersValueFileInfo = require('./parametersValueFileInfo');
exports.ArmTemplate = require('./armTemplate');
exports.ArmTemplateInfo = require('./armTemplateInfo');
exports.ArmTemplateParameterProperties = require('./armTemplateParameterProperties');
exports.ArmTemplateParameterPropertiesFragment = require('./armTemplateParameterPropertiesFragment');
exports.Artifact = require('./artifact');
exports.ArtifactDeploymentStatusProperties = require('./artifactDeploymentStatusProperties');
exports.ArtifactDeploymentStatusPropertiesFragment = require('./artifactDeploymentStatusPropertiesFragment');
exports.ArtifactParameterPropertiesFragment = require('./artifactParameterPropertiesFragment');
exports.ArtifactInstallPropertiesFragment = require('./artifactInstallPropertiesFragment');
exports.ArtifactSource = require('./artifactSource');
exports.ArtifactSourceFragment = require('./artifactSourceFragment');
exports.AttachDiskProperties = require('./attachDiskProperties');
exports.AttachNewDataDiskOptions = require('./attachNewDataDiskOptions');
exports.AttachNewDataDiskOptionsFragment = require('./attachNewDataDiskOptionsFragment');
exports.BulkCreationParameters = require('./bulkCreationParameters');
exports.BulkCreationParametersFragment = require('./bulkCreationParametersFragment');
exports.ComputeDataDisk = require('./computeDataDisk');
exports.ComputeDataDiskFragment = require('./computeDataDiskFragment');
exports.ComputeVmInstanceViewStatus = require('./computeVmInstanceViewStatus');
exports.ComputeVmInstanceViewStatusFragment = require('./computeVmInstanceViewStatusFragment');
exports.ComputeVmProperties = require('./computeVmProperties');
exports.ComputeVmPropertiesFragment = require('./computeVmPropertiesFragment');
exports.PercentageCostThresholdProperties = require('./percentageCostThresholdProperties');
exports.CostThresholdProperties = require('./costThresholdProperties');
exports.WindowsOsInfo = require('./windowsOsInfo');
exports.LinuxOsInfo = require('./linuxOsInfo');
exports.CustomImagePropertiesFromVm = require('./customImagePropertiesFromVm');
exports.CustomImagePropertiesCustom = require('./customImagePropertiesCustom');
exports.DataDiskStorageTypeInfo = require('./dataDiskStorageTypeInfo');
exports.CustomImagePropertiesFromPlan = require('./customImagePropertiesFromPlan');
exports.CustomImage = require('./customImage');
exports.WindowsOsInfoFragment = require('./windowsOsInfoFragment');
exports.LinuxOsInfoFragment = require('./linuxOsInfoFragment');
exports.CustomImagePropertiesFromVmFragment = require('./customImagePropertiesFromVmFragment');
exports.CustomImagePropertiesCustomFragment = require('./customImagePropertiesCustomFragment');
exports.DataDiskStorageTypeInfoFragment = require('./dataDiskStorageTypeInfoFragment');
exports.CustomImagePropertiesFromPlanFragment = require('./customImagePropertiesFromPlanFragment');
exports.CustomImageFragment = require('./customImageFragment');
exports.DataDiskProperties = require('./dataDiskProperties');
exports.DataDiskPropertiesFragment = require('./dataDiskPropertiesFragment');
exports.DetachDataDiskProperties = require('./detachDataDiskProperties');
exports.DetachDiskProperties = require('./detachDiskProperties');
exports.Disk = require('./disk');
exports.DiskFragment = require('./diskFragment');
exports.EnvironmentDeploymentProperties = require('./environmentDeploymentProperties');
exports.DtlEnvironment = require('./dtlEnvironment');
exports.EnvironmentDeploymentPropertiesFragment = require('./environmentDeploymentPropertiesFragment');
exports.DtlEnvironmentFragment = require('./dtlEnvironmentFragment');
exports.EvaluatePoliciesProperties = require('./evaluatePoliciesProperties');
exports.EvaluatePoliciesRequest = require('./evaluatePoliciesRequest');
exports.PolicyViolation = require('./policyViolation');
exports.PolicySetResult = require('./policySetResult');
exports.EvaluatePoliciesResponse = require('./evaluatePoliciesResponse');
exports.Event = require('./event');
exports.EventFragment = require('./eventFragment');
exports.ExportResourceUsageParameters = require('./exportResourceUsageParameters');
exports.ExternalSubnet = require('./externalSubnet');
exports.ExternalSubnetFragment = require('./externalSubnetFragment');
exports.GalleryImageReference = require('./galleryImageReference');
exports.InboundNatRule = require('./inboundNatRule');
exports.SharedPublicIpAddressConfiguration = require('./sharedPublicIpAddressConfiguration');
exports.NetworkInterfaceProperties = require('./networkInterfaceProperties');
exports.ScheduleCreationParameter = require('./scheduleCreationParameter');
exports.LabVirtualMachineCreationParameter = require('./labVirtualMachineCreationParameter');
exports.FormulaPropertiesFromVm = require('./formulaPropertiesFromVm');
exports.Formula = require('./formula');
exports.GalleryImageReferenceFragment = require('./galleryImageReferenceFragment');
exports.InboundNatRuleFragment = require('./inboundNatRuleFragment');
exports.SharedPublicIpAddressConfigurationFragment = require('./sharedPublicIpAddressConfigurationFragment');
exports.NetworkInterfacePropertiesFragment = require('./networkInterfacePropertiesFragment');
exports.ScheduleCreationParameterFragment = require('./scheduleCreationParameterFragment');
exports.LabVirtualMachineCreationParameterFragment = require('./labVirtualMachineCreationParameterFragment');
exports.FormulaPropertiesFromVmFragment = require('./formulaPropertiesFromVmFragment');
exports.FormulaFragment = require('./formulaFragment');
exports.GalleryImage = require('./galleryImage');
exports.ParameterInfo = require('./parameterInfo');
exports.GenerateArmTemplateRequest = require('./generateArmTemplateRequest');
exports.GenerateUploadUriParameter = require('./generateUploadUriParameter');
exports.GenerateUploadUriResponse = require('./generateUploadUriResponse');
exports.IdentityProperties = require('./identityProperties');
exports.ImportLabVirtualMachineRequest = require('./importLabVirtualMachineRequest');
exports.LabAnnouncementProperties = require('./labAnnouncementProperties');
exports.LabSupportProperties = require('./labSupportProperties');
exports.Lab = require('./lab');
exports.LabAnnouncementPropertiesFragment = require('./labAnnouncementPropertiesFragment');
exports.TargetCostProperties = require('./targetCostProperties');
exports.LabCostSummaryProperties = require('./labCostSummaryProperties');
exports.LabCostDetailsProperties = require('./labCostDetailsProperties');
exports.LabResourceCostProperties = require('./labResourceCostProperties');
exports.LabCost = require('./labCost');
exports.LabSupportPropertiesFragment = require('./labSupportPropertiesFragment');
exports.LabFragment = require('./labFragment');
exports.LabVhd = require('./labVhd');
exports.LabVirtualMachine = require('./labVirtualMachine');
exports.LabVirtualMachineFragment = require('./labVirtualMachineFragment');
exports.NotificationChannel = require('./notificationChannel');
exports.NotificationChannelFragment = require('./notificationChannelFragment');
exports.NotifyParameters = require('./notifyParameters');
exports.OperationError = require('./operationError');
exports.OperationMetadataDisplay = require('./operationMetadataDisplay');
exports.OperationMetadata = require('./operationMetadata');
exports.OperationResult = require('./operationResult');
exports.Policy = require('./policy');
exports.PolicyFragment = require('./policyFragment');
exports.Port = require('./port');
exports.PortFragment = require('./portFragment');
exports.RdpConnection = require('./rdpConnection');
exports.ResizeLabVirtualMachineProperties = require('./resizeLabVirtualMachineProperties');
exports.RetargetScheduleProperties = require('./retargetScheduleProperties');
exports.Secret = require('./secret');
exports.SecretFragment = require('./secretFragment');
exports.ServiceFabric = require('./serviceFabric');
exports.ServiceFabricFragment = require('./serviceFabricFragment');
exports.ServiceRunner = require('./serviceRunner');
exports.ShutdownNotificationContent = require('./shutdownNotificationContent');
exports.Subnet = require('./subnet');
exports.SubnetFragment = require('./subnetFragment');
exports.SubnetSharedPublicIpAddressConfiguration = require('./subnetSharedPublicIpAddressConfiguration');
exports.SubnetOverride = require('./subnetOverride');
exports.SubnetSharedPublicIpAddressConfigurationFragment = require('./subnetSharedPublicIpAddressConfigurationFragment');
exports.SubnetOverrideFragment = require('./subnetOverrideFragment');
exports.UserIdentity = require('./userIdentity');
exports.UserSecretStore = require('./userSecretStore');
exports.User = require('./user');
exports.UserIdentityFragment = require('./userIdentityFragment');
exports.UserSecretStoreFragment = require('./userSecretStoreFragment');
exports.UserFragment = require('./userFragment');
exports.VirtualNetwork = require('./virtualNetwork');
exports.VirtualNetworkFragment = require('./virtualNetworkFragment');
exports.ProviderOperationResult = require('./providerOperationResult');
exports.LabList = require('./labList');
exports.LabVhdList = require('./labVhdList');
exports.ScheduleList = require('./scheduleList');
exports.ArtifactSourceList = require('./artifactSourceList');
exports.ArmTemplateList = require('./armTemplateList');
exports.ArtifactList = require('./artifactList');
exports.CustomImageList = require('./customImageList');
exports.FormulaList = require('./formulaList');
exports.GalleryImageList = require('./galleryImageList');
exports.NotificationChannelList = require('./notificationChannelList');
exports.PolicyList = require('./policyList');
exports.ServiceRunnerList = require('./serviceRunnerList');
exports.UserList = require('./userList');
exports.DiskList = require('./diskList');
exports.DtlEnvironmentList = require('./dtlEnvironmentList');
exports.SecretList = require('./secretList');
exports.ServiceFabricList = require('./serviceFabricList');
exports.LabVirtualMachineList = require('./labVirtualMachineList');
exports.VirtualNetworkList = require('./virtualNetworkList');
