/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a lab's support banner
 *
 */
class LabSupportProperties {
  /**
   * Create a LabSupportProperties.
   * @property {string} [enabled] Is the lab support banner active/enabled at
   * this time?. Possible values include: 'Enabled', 'Disabled'
   * @property {string} [markdown] The markdown text (if any) that this lab
   * displays in the UI. If left empty/null, nothing will be shown.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LabSupportProperties
   *
   * @returns {object} metadata of LabSupportProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LabSupportProperties',
      type: {
        name: 'Composite',
        className: 'LabSupportProperties',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'String'
            }
          },
          markdown: {
            required: false,
            serializedName: 'markdown',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LabSupportProperties;
