/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A Service Fabric.
 *
 * @extends models['UpdateResource']
 */
class ServiceFabricFragment extends models['UpdateResource'] {
  /**
   * Create a ServiceFabricFragment.
   * @property {string} [externalServiceFabricId] The backing service fabric
   * resource's id
   * @property {string} [environmentId] The resource id of the environment
   * under which the service fabric resource is present
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceFabricFragment
   *
   * @returns {object} metadata of ServiceFabricFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceFabricFragment',
      type: {
        name: 'Composite',
        className: 'ServiceFabricFragment',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          externalServiceFabricId: {
            required: false,
            serializedName: 'properties.externalServiceFabricId',
            type: {
              name: 'String'
            }
          },
          environmentId: {
            required: false,
            serializedName: 'properties.environmentId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceFabricFragment;
