/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a cost target.
 *
 */
class TargetCostProperties {
  /**
   * Create a TargetCostProperties.
   * @property {string} [status] Target cost status. Possible values include:
   * 'Enabled', 'Disabled'
   * @property {number} [target] Lab target cost
   * @property {array} [costThresholds] Cost thresholds.
   * @property {date} [cycleStartDateTime] Reporting cycle start date.
   * @property {date} [cycleEndDateTime] Reporting cycle end date.
   * @property {string} [cycleType] Reporting cycle type. Possible values
   * include: 'CalendarMonth', 'Custom'
   */
  constructor() {
  }

  /**
   * Defines the metadata of TargetCostProperties
   *
   * @returns {object} metadata of TargetCostProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TargetCostProperties',
      type: {
        name: 'Composite',
        className: 'TargetCostProperties',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'Number'
            }
          },
          costThresholds: {
            required: false,
            serializedName: 'costThresholds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CostThresholdPropertiesElementType',
                  type: {
                    name: 'Composite',
                    className: 'CostThresholdProperties'
                  }
              }
            }
          },
          cycleStartDateTime: {
            required: false,
            serializedName: 'cycleStartDateTime',
            type: {
              name: 'DateTime'
            }
          },
          cycleEndDateTime: {
            required: false,
            serializedName: 'cycleEndDateTime',
            type: {
              name: 'DateTime'
            }
          },
          cycleType: {
            required: false,
            serializedName: 'cycleType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TargetCostProperties;
