/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A virtual network.
 *
 * @extends models['UpdateResource']
 */
class VirtualNetworkFragment extends models['UpdateResource'] {
  /**
   * Create a VirtualNetworkFragment.
   * @property {array} [allowedSubnets] The allowed subnets of the virtual
   * network.
   * @property {string} [description] The description of the virtual network.
   * @property {string} [externalProviderResourceId] The Microsoft.Network
   * resource identifier of the virtual network.
   * @property {array} [subnetOverrides] The subnet overrides of the virtual
   * network.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VirtualNetworkFragment
   *
   * @returns {object} metadata of VirtualNetworkFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualNetworkFragment',
      type: {
        name: 'Composite',
        className: 'VirtualNetworkFragment',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          allowedSubnets: {
            required: false,
            serializedName: 'properties.allowedSubnets',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SubnetFragmentElementType',
                  type: {
                    name: 'Composite',
                    className: 'SubnetFragment'
                  }
              }
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          externalProviderResourceId: {
            required: false,
            serializedName: 'properties.externalProviderResourceId',
            type: {
              name: 'String'
            }
          },
          subnetOverrides: {
            required: false,
            serializedName: 'properties.subnetOverrides',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SubnetOverrideFragmentElementType',
                  type: {
                    name: 'Composite',
                    className: 'SubnetOverrideFragment'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualNetworkFragment;
