/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error details.
 *
 */
class ErrorDetails {
  /**
   * Create a ErrorDetails.
   * @member {string} [code] The error code.
   * @member {string} [httpStatusCode] The HTTP status code.
   * @member {string} [message] The error message.
   * @member {string} [details] The error details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorDetails
   *
   * @returns {object} metadata of ErrorDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorDetails',
      type: {
        name: 'Composite',
        className: 'ErrorDetails',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          httpStatusCode: {
            required: false,
            readOnly: true,
            serializedName: 'httpStatusCode',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            readOnly: true,
            serializedName: 'details',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorDetails;
