/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * List of possible provisoning service SKUs.
 *
 */
class IotDpsSkuInfo {
  /**
   * Create a IotDpsSkuInfo.
   * @member {string} [name] Sku name. Possible values include: 'S1'
   * @member {string} [tier] Pricing tier name of the provisioning service.
   * @member {number} [capacity] The number of units to provision
   */
  constructor() {
  }

  /**
   * Defines the metadata of IotDpsSkuInfo
   *
   * @returns {object} metadata of IotDpsSkuInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IotDpsSkuInfo',
      type: {
        name: 'Composite',
        className: 'IotDpsSkuInfo',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            readOnly: true,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = IotDpsSkuInfo;
