/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Description of the response of the verification code.
 *
 * @extends models['BaseResource']
 */
class VerificationCodeResponse extends models['BaseResource'] {
  /**
   * Create a VerificationCodeResponse.
   * @member {string} [name] Name of certificate.
   * @member {string} [etag] Request etag.
   * @member {string} [id] The resource identifier.
   * @member {string} [type] The resource type.
   * @member {object} [properties]
   * @member {string} [properties.verificationCode] Verification code.
   * @member {string} [properties.subject] Certificate subject.
   * @member {string} [properties.expiry] Code expiry.
   * @member {string} [properties.thumbprint] Certificate thumbprint.
   * @member {boolean} [properties.isVerified] Indicate if the certificate is
   * verified by owner of private key.
   * @member {string} [properties.created] Certificate created time.
   * @member {string} [properties.updated] Certificate updated time.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VerificationCodeResponse
   *
   * @returns {object} metadata of VerificationCodeResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VerificationCodeResponse',
      type: {
        name: 'Composite',
        className: 'VerificationCodeResponse',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'VerificationCodeResponseProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = VerificationCodeResponse;
