/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a contractual rule for text attribution.
 *
 * @extends models['ContractualRulesAttribution']
 */
class ContractualRulesTextAttribution extends models['ContractualRulesAttribution'] {
  /**
   * Create a ContractualRulesTextAttribution.
   * @property {string} text The attribution text. Text attribution applies to
   * the entity as a whole and should be displayed immediately following the
   * entity presentation. If there are multiple text or link attribution rules
   * that do not specify a target, you should concatenate them and display them
   * using a "Data from:" label.
   * @property {boolean} [optionalForListDisplay] Indicates whether this
   * provider's attribution is optional.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ContractualRulesTextAttribution
   *
   * @returns {object} metadata of ContractualRulesTextAttribution
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContractualRules/TextAttribution',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ContractualRulesContractualRule',
        className: 'ContractualRulesTextAttribution',
        modelProperties: {
          targetPropertyName: {
            required: false,
            readOnly: true,
            serializedName: 'targetPropertyName',
            type: {
              name: 'String'
            }
          },
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          mustBeCloseToContent: {
            required: false,
            readOnly: true,
            serializedName: 'mustBeCloseToContent',
            type: {
              name: 'Boolean'
            }
          },
          text: {
            required: true,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          optionalForListDisplay: {
            required: false,
            readOnly: true,
            serializedName: 'optionalForListDisplay',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ContractualRulesTextAttribution;
