/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The target of the event.
 *
 */
class ContainerRegistryEventTarget {
  /**
   * Create a ContainerRegistryEventTarget.
   * @member {string} [mediaType] The MIME type of the referenced object.
   * @member {number} [size] The number of bytes of the content. Same as Length
   * field.
   * @member {string} [digest] The digest of the content, as defined by the
   * Registry V2 HTTP API Specification.
   * @member {number} [length] The number of bytes of the content. Same as Size
   * field.
   * @member {string} [repository] The repository name.
   * @member {string} [url] The direct URL to the content.
   * @member {string} [tag] The tag name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerRegistryEventTarget
   *
   * @returns {object} metadata of ContainerRegistryEventTarget
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerRegistryEventTarget',
      type: {
        name: 'Composite',
        className: 'ContainerRegistryEventTarget',
        modelProperties: {
          mediaType: {
            required: false,
            serializedName: 'mediaType',
            type: {
              name: 'String'
            }
          },
          size: {
            required: false,
            serializedName: 'size',
            type: {
              name: 'Number'
            }
          },
          digest: {
            required: false,
            serializedName: 'digest',
            type: {
              name: 'String'
            }
          },
          length: {
            required: false,
            serializedName: 'length',
            type: {
              name: 'Number'
            }
          },
          repository: {
            required: false,
            serializedName: 'repository',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          tag: {
            required: false,
            serializedName: 'tag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerRegistryEventTarget;
