/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Schema of the Data property of an EventGridEvent for a
 * Microsoft.ContainerRegistry.ImagePushed event.
 *
 * @extends models['ContainerRegistryEventData']
 */
class ContainerRegistryImagePushedEventData extends models['ContainerRegistryEventData'] {
  /**
   * Create a ContainerRegistryImagePushedEventData.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ContainerRegistryImagePushedEventData
   *
   * @returns {object} metadata of ContainerRegistryImagePushedEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerRegistryImagePushedEventData',
      type: {
        name: 'Composite',
        className: 'ContainerRegistryImagePushedEventData',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          timestamp: {
            required: false,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          action: {
            required: false,
            serializedName: 'action',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'Composite',
              className: 'ContainerRegistryEventTarget'
            }
          },
          request: {
            required: false,
            serializedName: 'request',
            type: {
              name: 'Composite',
              className: 'ContainerRegistryEventRequest'
            }
          },
          actor: {
            required: false,
            serializedName: 'actor',
            type: {
              name: 'Composite',
              className: 'ContainerRegistryEventActor'
            }
          },
          source: {
            required: false,
            serializedName: 'source',
            type: {
              name: 'Composite',
              className: 'ContainerRegistryEventSource'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerRegistryImagePushedEventData;
