/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Schema of the Data property of an EventGridEvent for a device telemetry
 * event (DeviceTelemetry).
 *
 */
class DeviceTelemetryEventProperties {
  /**
   * Create a DeviceTelemetryEventProperties.
   * @member {object} [body] The content of the message from the device.
   * @member {object} [properties] Application properties are user-defined
   * strings that can be added to the message. These fields are optional.
   * @member {object} [systemProperties] System properties help identify
   * contents and source of the messages.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceTelemetryEventProperties
   *
   * @returns {object} metadata of DeviceTelemetryEventProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceTelemetryEventProperties',
      type: {
        name: 'Composite',
        className: 'DeviceTelemetryEventProperties',
        modelProperties: {
          body: {
            required: false,
            serializedName: 'body',
            type: {
              name: 'Object'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          systemProperties: {
            required: false,
            serializedName: 'systemProperties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceTelemetryEventProperties;
