/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The thumbprint is a unique value for the x509 certificate, commonly used to
 * find a particular certificate in a certificate store. The thumbprint is
 * dynamically generated using the SHA1 algorithm, and does not physically
 * exist in the certificate.
 *
 */
class DeviceTwinInfoX509Thumbprint {
  /**
   * Create a DeviceTwinInfoX509Thumbprint.
   * @member {string} [primaryThumbprint] Primary thumbprint for the x509
   * certificate.
   * @member {string} [secondaryThumbprint] Secondary thumbprint for the x509
   * certificate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeviceTwinInfoX509Thumbprint
   *
   * @returns {object} metadata of DeviceTwinInfoX509Thumbprint
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeviceTwinInfo_x509Thumbprint',
      type: {
        name: 'Composite',
        className: 'DeviceTwinInfoX509Thumbprint',
        modelProperties: {
          primaryThumbprint: {
            required: false,
            serializedName: 'primaryThumbprint',
            type: {
              name: 'String'
            }
          },
          secondaryThumbprint: {
            required: false,
            serializedName: 'secondaryThumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeviceTwinInfoX509Thumbprint;
