/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Job output error event data
 *
 * @extends models['MediaJobOutputStateChangeEventData']
 */
class MediaJobOutputErroredEventData extends models['MediaJobOutputStateChangeEventData'] {
  /**
   * Create a MediaJobOutputErroredEventData.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MediaJobOutputErroredEventData
   *
   * @returns {object} metadata of MediaJobOutputErroredEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.JobOutputErrored',
      type: {
        name: 'Composite',
        className: 'MediaJobOutputErroredEventData',
        modelProperties: {
          previousState: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'previousState',
            type: {
              name: 'Enum',
              allowedValues: [ 'Canceled', 'Canceling', 'Error', 'Finished', 'Processing', 'Queued', 'Scheduled' ]
            }
          },
          output: {
            required: false,
            serializedName: 'output',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '@odata.type',
                clientName: 'odatatype'
              },
              uberParent: 'MediaJobOutput',
              className: 'MediaJobOutput'
            }
          },
          jobCorrelationData: {
            required: false,
            serializedName: 'jobCorrelationData',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MediaJobOutputErroredEventData;
