/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Job Output Progress Event Data.
 *
 */
class MediaJobOutputProgressEventData {
  /**
   * Create a MediaJobOutputProgressEventData.
   * @member {string} [label] Gets the Job output label.
   * @member {number} [progress] Gets the Job output progress.
   * @member {object} [jobCorrelationData] Gets the Job correlation data.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MediaJobOutputProgressEventData
   *
   * @returns {object} metadata of MediaJobOutputProgressEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.JobOutputProgress',
      type: {
        name: 'Composite',
        className: 'MediaJobOutputProgressEventData',
        modelProperties: {
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          progress: {
            required: false,
            serializedName: 'progress',
            type: {
              name: 'Number'
            }
          },
          jobCorrelationData: {
            required: false,
            serializedName: 'jobCorrelationData',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MediaJobOutputProgressEventData;
