/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Job processing event data
 *
 * @extends models['MediaJobStateChangeEventData']
 */
class MediaJobProcessingEventData extends models['MediaJobStateChangeEventData'] {
  /**
   * Create a MediaJobProcessingEventData.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MediaJobProcessingEventData
   *
   * @returns {object} metadata of MediaJobProcessingEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.JobProcessing',
      type: {
        name: 'Composite',
        className: 'MediaJobProcessingEventData',
        modelProperties: {
          previousState: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'previousState',
            type: {
              name: 'Enum',
              allowedValues: [ 'Canceled', 'Canceling', 'Error', 'Finished', 'Processing', 'Queued', 'Scheduled' ]
            }
          },
          state: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'state',
            type: {
              name: 'Enum',
              allowedValues: [ 'Canceled', 'Canceling', 'Error', 'Finished', 'Processing', 'Queued', 'Scheduled' ]
            }
          },
          correlationData: {
            required: false,
            serializedName: 'correlationData',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MediaJobProcessingEventData;
