/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Domain Topic
 *
 * @extends models['Resource']
 */
class DomainTopic extends models['Resource'] {
  /**
   * Create a DomainTopic.
   * @property {string} [provisioningState] Provisioning state of the domain
   * topic. Possible values include: 'Creating', 'Updating', 'Deleting',
   * 'Succeeded', 'Canceled', 'Failed'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DomainTopic
   *
   * @returns {object} metadata of DomainTopic
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DomainTopic',
      type: {
        name: 'Composite',
        className: 'DomainTopic',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DomainTopic;
