/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This is used to express the source of an input schema mapping for a single
 * target field in the Event Grid Event schema. This is currently used in the
 * mappings for the 'id', 'topic' and 'eventtime' properties. This represents a
 * field in the input event schema.
 *
 */
class JsonField {
  /**
   * Create a JsonField.
   * @property {string} [sourceField] Name of a field in the input event schema
   * that's to be used as the source of a mapping.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JsonField
   *
   * @returns {object} metadata of JsonField
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JsonField',
      type: {
        name: 'Composite',
        className: 'JsonField',
        modelProperties: {
          sourceField: {
            required: false,
            serializedName: 'sourceField',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JsonField;
