/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * StringBeginsWith Advanced Filter.
 *
 * @extends models['AdvancedFilter']
 */
class StringBeginsWithAdvancedFilter extends models['AdvancedFilter'] {
  /**
   * Create a StringBeginsWithAdvancedFilter.
   * @property {array} [values] The set of filter values.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StringBeginsWithAdvancedFilter
   *
   * @returns {object} metadata of StringBeginsWithAdvancedFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StringBeginsWith',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'operatorType',
          clientName: 'operatorType'
        },
        uberParent: 'AdvancedFilter',
        className: 'StringBeginsWithAdvancedFilter',
        modelProperties: {
          key: {
            required: false,
            serializedName: 'key',
            type: {
              name: 'String'
            }
          },
          operatorType: {
            required: true,
            serializedName: 'operatorType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          values: {
            required: false,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = StringBeginsWithAdvancedFilter;
