/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Frontend endpoint used in routing rule
 *
 */
class FrontendEndpointUpdateParameters {
  /**
   * Create a FrontendEndpointUpdateParameters.
   * @member {string} [hostName] The host name of the frontendEndpoint. Must be
   * a domain name.
   * @member {string} [sessionAffinityEnabledState] Whether to allow session
   * affinity on this host. Valid options are 'Enabled' or 'Disabled'. Possible
   * values include: 'Enabled', 'Disabled'
   * @member {number} [sessionAffinityTtlSeconds] UNUSED. This field will be
   * ignored. The TTL to use in seconds for session affinity, if applicable.
   * @member {object} [webApplicationFirewallPolicyLink] Defines the Web
   * Application Firewall policy for each host (if applicable)
   * @member {string} [webApplicationFirewallPolicyLink.id] Resource ID.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FrontendEndpointUpdateParameters
   *
   * @returns {object} metadata of FrontendEndpointUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FrontendEndpointUpdateParameters',
      type: {
        name: 'Composite',
        className: 'FrontendEndpointUpdateParameters',
        modelProperties: {
          hostName: {
            required: false,
            serializedName: 'hostName',
            type: {
              name: 'String'
            }
          },
          sessionAffinityEnabledState: {
            required: false,
            serializedName: 'sessionAffinityEnabledState',
            type: {
              name: 'String'
            }
          },
          sessionAffinityTtlSeconds: {
            required: false,
            serializedName: 'sessionAffinityTtlSeconds',
            type: {
              name: 'Number'
            }
          },
          webApplicationFirewallPolicyLink: {
            required: false,
            serializedName: 'webApplicationFirewallPolicyLink',
            type: {
              name: 'Composite',
              className: 'FrontendEndpointUpdateParametersWebApplicationFirewallPolicyLink'
            }
          }
        }
      }
    };
  }
}

module.exports = FrontendEndpointUpdateParameters;
