/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the hardware settings for the HANA instance.
 *
 */
class HardwareProfile {
  /**
   * Create a HardwareProfile.
   * @property {string} [hardwareType] Name of the hardware type (vendor and/or
   * their product name). Possible values include: 'Cisco_UCS', 'HPE'
   * @property {string} [hanaInstanceSize] Specifies the HANA instance SKU.
   * Possible values include: 'S72m', 'S144m', 'S72', 'S144', 'S192', 'S192m',
   * 'S192xm', 'S96', 'S384', 'S384m', 'S384xm', 'S384xxm', 'S576m', 'S576xm',
   * 'S768', 'S768m', 'S768xm', 'S960m'
   */
  constructor() {
  }

  /**
   * Defines the metadata of HardwareProfile
   *
   * @returns {object} metadata of HardwareProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HardwareProfile',
      type: {
        name: 'Composite',
        className: 'HardwareProfile',
        modelProperties: {
          hardwareType: {
            required: false,
            readOnly: true,
            serializedName: 'hardwareType',
            type: {
              name: 'String'
            }
          },
          hanaInstanceSize: {
            required: false,
            readOnly: true,
            serializedName: 'hanaInstanceSize',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HardwareProfile;
