/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Disk Encryption Cluster request parameters.
 *
 */
class ClusterDiskEncryptionParameters {
  /**
   * Create a ClusterDiskEncryptionParameters.
   * @property {string} [vaultUri] Base key vault URI where the customers key
   * is located eg. https://myvault.vault.azure.net
   * @property {string} [keyName] Key name that is used for enabling disk
   * encryption.
   * @property {string} [keyVersion] Specific key version that is used for
   * enabling disk encryption.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterDiskEncryptionParameters
   *
   * @returns {object} metadata of ClusterDiskEncryptionParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterDiskEncryptionParameters',
      type: {
        name: 'Composite',
        className: 'ClusterDiskEncryptionParameters',
        modelProperties: {
          vaultUri: {
            required: false,
            serializedName: 'vaultUri',
            type: {
              name: 'String'
            }
          },
          keyName: {
            required: false,
            serializedName: 'keyName',
            type: {
              name: 'String'
            }
          },
          keyVersion: {
            required: false,
            serializedName: 'keyVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterDiskEncryptionParameters;
