/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a region of an image. The region is defined by the coordinates of
 * the top, left corner and bottom, right corner of the region. The coordinates
 * are fractional values of the original image's width and height in the range
 * 0.0 through 1.0.
 *
 * @extends models['StructuredValue']
 */
class NormalizedRectangle extends models['StructuredValue'] {
  /**
   * Create a NormalizedRectangle.
   * @property {number} left The left coordinate.
   * @property {number} top The top coordinate
   * @property {number} right The right coordinate
   * @property {number} bottom The bottom coordinate
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NormalizedRectangle
   *
   * @returns {object} metadata of NormalizedRectangle
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NormalizedRectangle',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ResponseBase',
        className: 'NormalizedRectangle',
        modelProperties: {
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          readLink: {
            required: false,
            readOnly: true,
            serializedName: 'readLink',
            type: {
              name: 'String'
            }
          },
          webSearchUrl: {
            required: false,
            readOnly: true,
            serializedName: 'webSearchUrl',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            readOnly: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          image: {
            required: false,
            readOnly: true,
            serializedName: 'image',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'ImageObject'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          alternateName: {
            required: false,
            readOnly: true,
            serializedName: 'alternateName',
            type: {
              name: 'String'
            }
          },
          bingId: {
            required: false,
            readOnly: true,
            serializedName: 'bingId',
            type: {
              name: 'String'
            }
          },
          left: {
            required: true,
            serializedName: 'left',
            type: {
              name: 'Number'
            }
          },
          top: {
            required: true,
            serializedName: 'top',
            type: {
              name: 'Number'
            }
          },
          right: {
            required: true,
            serializedName: 'right',
            type: {
              name: 'Number'
            }
          },
          bottom: {
            required: true,
            serializedName: 'bottom',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = NormalizedRectangle;
