/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The top-level object that the response includes when a trending images
 * request succeeds.
 *
 * @extends models['Response']
 */
class TrendingImages extends models['Response'] {
  /**
   * Create a TrendingImages.
   * @property {array} categories A list that identifies categories of images
   * and a list of trending images in that category.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TrendingImages
   *
   * @returns {object} metadata of TrendingImages
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrendingImages',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ResponseBase',
        className: 'TrendingImages',
        modelProperties: {
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          readLink: {
            required: false,
            readOnly: true,
            serializedName: 'readLink',
            type: {
              name: 'String'
            }
          },
          webSearchUrl: {
            required: false,
            readOnly: true,
            serializedName: 'webSearchUrl',
            type: {
              name: 'String'
            }
          },
          categories: {
            required: true,
            serializedName: 'categories',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TrendingImagesCategoryElementType',
                  type: {
                    name: 'Composite',
                    className: 'TrendingImagesCategory'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TrendingImages;
