/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error details.
 *
 */
class ErrorDetails {
  /**
   * Create a ErrorDetails.
   * @member {string} [code] The error code.
   * @member {string} [message] The error message.
   * @member {string} [target] The target of the particular error.
   * @member {array} [details] A list of additional details about the error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorDetails
   *
   * @returns {object} metadata of ErrorDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorDetails',
      type: {
        name: 'Composite',
        className: 'ErrorDetails',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'error.code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'error.message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            readOnly: true,
            serializedName: 'error.target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'error.details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ErrorResponseBodyElementType',
                  type: {
                    name: 'Composite',
                    className: 'ErrorResponseBody'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorDetails;
