/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties of the EventHubConsumerGroupInfo object.
 *
 * @extends models['BaseResource']
 */
class EventHubConsumerGroupInfo extends models['BaseResource'] {
  /**
   * Create a EventHubConsumerGroupInfo.
   * @member {object} [properties] The tags.
   * @member {string} [id] The Event Hub-compatible consumer group identifier.
   * @member {string} [name] The Event Hub-compatible consumer group name.
   * @member {string} [type] the resource type.
   * @member {string} [etag] The etag.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EventHubConsumerGroupInfo
   *
   * @returns {object} metadata of EventHubConsumerGroupInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventHubConsumerGroupInfo',
      type: {
        name: 'Composite',
        className: 'EventHubConsumerGroupInfo',
        modelProperties: {
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventHubConsumerGroupInfo;
