/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * IoTSpaces service REST API operation
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] Operation name: {provider}/{resource}/{read |
   * write | action | delete}
   * @member {object} [display]
   * @member {string} [display.provider] Service provider: Microsoft IoTSpaces
   * @member {string} [display.resource] Resource Type: IoTSpaces
   * @member {string} [display.operation] Name of the operation
   * @member {string} [display.description] Friendly description for the
   * operation,
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
