/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing an data connection validation.
 *
 */
class DataConnectionValidation {
  /**
   * Create a DataConnectionValidation.
   * @property {string} [dataConnectionName] The name of the data connection.
   * @property {object} [properties] The data connection properties to
   * validate.
   * @property {string} [properties.location] Resource location.
   * @property {string} [properties.kind] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataConnectionValidation
   *
   * @returns {object} metadata of DataConnectionValidation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataConnectionValidation',
      type: {
        name: 'Composite',
        className: 'DataConnectionValidation',
        modelProperties: {
          dataConnectionName: {
            required: false,
            serializedName: 'dataConnectionName',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'kind',
                clientName: 'kind'
              },
              uberParent: 'BaseResource',
              className: 'DataConnection'
            }
          }
        }
      }
    };
  }
}

module.exports = DataConnectionValidation;
