/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The availability information of sizes across regions
 *
 */
class RegionalAvailability {
  /**
   * Create a RegionalAvailability.
   * @property {string} [region] Corresponding region
   * @property {array} [sizeAvailabilities] List of all the size information
   * for the region
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegionalAvailability
   *
   * @returns {object} metadata of RegionalAvailability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegionalAvailability',
      type: {
        name: 'Composite',
        className: 'RegionalAvailability',
        modelProperties: {
          region: {
            required: false,
            serializedName: 'region',
            type: {
              name: 'String'
            }
          },
          sizeAvailabilities: {
            required: false,
            serializedName: 'sizeAvailabilities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SizeAvailabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'SizeAvailability'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RegionalAvailability;
