/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains detailed information about a size
 *
 */
class SizeInfoFragment {
  /**
   * Create a SizeInfoFragment.
   * @property {string} [computeSize] Represents the actual compute size, e.g.
   * Standard_A2_v2.
   * @property {number} [price] The pay-as-you-go price per hour this size will
   * cost. It does not include discounts and may not reflect the actual price
   * the size will cost.
   * @property {number} [numberOfCores] The number of cores a VM of this size
   * has.
   * @property {number} [memory] The amount of memory available (in GB).
   */
  constructor() {
  }

  /**
   * Defines the metadata of SizeInfoFragment
   *
   * @returns {object} metadata of SizeInfoFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SizeInfoFragment',
      type: {
        name: 'Composite',
        className: 'SizeInfoFragment',
        modelProperties: {
          computeSize: {
            required: false,
            serializedName: 'computeSize',
            type: {
              name: 'String'
            }
          },
          price: {
            required: false,
            serializedName: 'price',
            type: {
              name: 'Number'
            }
          },
          numberOfCores: {
            required: false,
            serializedName: 'numberOfCores',
            type: {
              name: 'Number'
            }
          },
          memory: {
            required: false,
            serializedName: 'memory',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SizeInfoFragment;
