/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The description of what resources to move between resource groups.
 *
 */
class LocationBasedServicesAccountsMoveRequest {
  /**
   * Create a LocationBasedServicesAccountsMoveRequest.
   * @member {string} targetResourceGroup The name of the destination resource
   * group.
   * @member {array} resourceIds A list of resource names to move from the
   * source resource group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LocationBasedServicesAccountsMoveRequest
   *
   * @returns {object} metadata of LocationBasedServicesAccountsMoveRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LocationBasedServicesAccountsMoveRequest',
      type: {
        name: 'Composite',
        className: 'LocationBasedServicesAccountsMoveRequest',
        modelProperties: {
          targetResourceGroup: {
            required: true,
            serializedName: 'targetResourceGroup',
            type: {
              name: 'String'
            }
          },
          resourceIds: {
            required: true,
            serializedName: 'resourceIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = LocationBasedServicesAccountsMoveRequest;
