/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Edifact envelope override settings.
 *
 */
class EdifactEnvelopeOverride {
  /**
   * Create a EdifactEnvelopeOverride.
   * @property {string} [messageId] The message id on which this envelope
   * settings has to be applied.
   * @property {string} [messageVersion] The message version on which this
   * envelope settings has to be applied.
   * @property {string} [messageRelease] The message release version on which
   * this envelope settings has to be applied.
   * @property {string} [messageAssociationAssignedCode] The message
   * association assigned code.
   * @property {string} [targetNamespace] The target namespace on which this
   * envelope settings has to be applied.
   * @property {string} [functionalGroupId] The functional group id.
   * @property {string} [senderApplicationQualifier] The sender application
   * qualifier.
   * @property {string} [senderApplicationId] The sender application id.
   * @property {string} [receiverApplicationQualifier] The receiver application
   * qualifier.
   * @property {string} [receiverApplicationId] The receiver application id.
   * @property {string} [controllingAgencyCode] The controlling agency code.
   * @property {string} [groupHeaderMessageVersion] The group header message
   * version.
   * @property {string} [groupHeaderMessageRelease] The group header message
   * release.
   * @property {string} [associationAssignedCode] The association assigned
   * code.
   * @property {string} [applicationPassword] The application password.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EdifactEnvelopeOverride
   *
   * @returns {object} metadata of EdifactEnvelopeOverride
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EdifactEnvelopeOverride',
      type: {
        name: 'Composite',
        className: 'EdifactEnvelopeOverride',
        modelProperties: {
          messageId: {
            required: false,
            serializedName: 'messageId',
            type: {
              name: 'String'
            }
          },
          messageVersion: {
            required: false,
            serializedName: 'messageVersion',
            type: {
              name: 'String'
            }
          },
          messageRelease: {
            required: false,
            serializedName: 'messageRelease',
            type: {
              name: 'String'
            }
          },
          messageAssociationAssignedCode: {
            required: false,
            serializedName: 'messageAssociationAssignedCode',
            type: {
              name: 'String'
            }
          },
          targetNamespace: {
            required: false,
            serializedName: 'targetNamespace',
            type: {
              name: 'String'
            }
          },
          functionalGroupId: {
            required: false,
            serializedName: 'functionalGroupId',
            type: {
              name: 'String'
            }
          },
          senderApplicationQualifier: {
            required: false,
            serializedName: 'senderApplicationQualifier',
            type: {
              name: 'String'
            }
          },
          senderApplicationId: {
            required: false,
            serializedName: 'senderApplicationId',
            type: {
              name: 'String'
            }
          },
          receiverApplicationQualifier: {
            required: false,
            serializedName: 'receiverApplicationQualifier',
            type: {
              name: 'String'
            }
          },
          receiverApplicationId: {
            required: false,
            serializedName: 'receiverApplicationId',
            type: {
              name: 'String'
            }
          },
          controllingAgencyCode: {
            required: false,
            serializedName: 'controllingAgencyCode',
            type: {
              name: 'String'
            }
          },
          groupHeaderMessageVersion: {
            required: false,
            serializedName: 'groupHeaderMessageVersion',
            type: {
              name: 'String'
            }
          },
          groupHeaderMessageRelease: {
            required: false,
            serializedName: 'groupHeaderMessageRelease',
            type: {
              name: 'String'
            }
          },
          associationAssignedCode: {
            required: false,
            serializedName: 'associationAssignedCode',
            type: {
              name: 'String'
            }
          },
          applicationPassword: {
            required: false,
            serializedName: 'applicationPassword',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EdifactEnvelopeOverride;
