/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a TrackingEventsDefinition.
 */
class TrackingEventsDefinition {
  /**
   * Create a TrackingEventsDefinition.
   * @property {string} sourceType
   * @property {string} [trackEventsOptions] Possible values include: 'None',
   * 'DisableSourceInfoEnrich'
   * @property {array} events
   */
  constructor() {
  }

  /**
   * Defines the metadata of TrackingEventsDefinition
   *
   * @returns {object} metadata of TrackingEventsDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrackingEventsDefinition',
      type: {
        name: 'Composite',
        className: 'TrackingEventsDefinition',
        modelProperties: {
          sourceType: {
            required: true,
            serializedName: 'sourceType',
            type: {
              name: 'String'
            }
          },
          trackEventsOptions: {
            required: false,
            serializedName: 'trackEventsOptions',
            type: {
              name: 'String'
            }
          },
          events: {
            required: true,
            serializedName: 'events',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TrackingEventElementType',
                  type: {
                    name: 'Composite',
                    className: 'TrackingEvent'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TrackingEventsDefinition;
