/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The base class "ProductionOrStagingEndpointInfo" inherits from.
 *
 */
class EndpointInfo {
  /**
   * Create a EndpointInfo.
   * @property {string} [versionId] The version ID to publish.
   * @property {boolean} [isStaging] Indicates if the staging slot should be
   * used, instead of the Production one.
   * @property {string} [endpointUrl] The Runtime endpoint URL for this model
   * version.
   * @property {string} [region] The target region that the application is
   * published to.
   * @property {string} [assignedEndpointKey] The endpoint key.
   * @property {string} [endpointRegion] The endpoint's region.
   * @property {string} [failedRegions] Regions where publishing failed.
   * @property {string} [publishedDateTime] Timestamp when was last published.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EndpointInfo
   *
   * @returns {object} metadata of EndpointInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EndpointInfo',
      type: {
        name: 'Composite',
        className: 'EndpointInfo',
        modelProperties: {
          versionId: {
            required: false,
            serializedName: 'versionId',
            type: {
              name: 'String'
            }
          },
          isStaging: {
            required: false,
            serializedName: 'isStaging',
            type: {
              name: 'Boolean'
            }
          },
          endpointUrl: {
            required: false,
            serializedName: 'endpointUrl',
            type: {
              name: 'String'
            }
          },
          region: {
            required: false,
            serializedName: 'region',
            type: {
              name: 'String'
            }
          },
          assignedEndpointKey: {
            required: false,
            serializedName: 'assignedEndpointKey',
            type: {
              name: 'String'
            }
          },
          endpointRegion: {
            required: false,
            serializedName: 'endpointRegion',
            type: {
              name: 'String'
            }
          },
          failedRegions: {
            required: false,
            serializedName: 'failedRegions',
            type: {
              name: 'String'
            }
          },
          publishedDateTime: {
            required: false,
            serializedName: 'publishedDateTime',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EndpointInfo;
