/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A labeled example.
 *
 */
class ExampleLabelObject {
  /**
   * Create a ExampleLabelObject.
   * @property {string} [text] The sample's utterance.
   * @property {array} [entityLabels] The identified entities within the
   * utterance.
   * @property {string} [intentName] The identified intent representing the
   * utterance.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExampleLabelObject
   *
   * @returns {object} metadata of ExampleLabelObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExampleLabelObject',
      type: {
        name: 'Composite',
        className: 'ExampleLabelObject',
        modelProperties: {
          text: {
            required: false,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          entityLabels: {
            required: false,
            serializedName: 'entityLabels',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EntityLabelObjectElementType',
                  type: {
                    name: 'Composite',
                    className: 'EntityLabelObject'
                  }
              }
            }
          },
          intentName: {
            required: false,
            serializedName: 'intentName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExampleLabelObject;
