/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The base class Features-related response objects inherit from.
 *
 */
class FeatureInfoObject {
  /**
   * Create a FeatureInfoObject.
   * @property {number} [id] A six-digit ID used for Features.
   * @property {string} [name] The name of the Feature.
   * @property {boolean} [isActive] Indicates if the feature is enabled.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FeatureInfoObject
   *
   * @returns {object} metadata of FeatureInfoObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FeatureInfoObject',
      type: {
        name: 'Composite',
        className: 'FeatureInfoObject',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          isActive: {
            required: false,
            serializedName: 'isActive',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = FeatureInfoObject;
