/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Model Features, including Patterns and Phraselists.
 *
 */
class FeaturesResponseObject {
  /**
   * Create a FeaturesResponseObject.
   * @property {array} [phraselistFeatures]
   * @property {array} [patternFeatures]
   */
  constructor() {
  }

  /**
   * Defines the metadata of FeaturesResponseObject
   *
   * @returns {object} metadata of FeaturesResponseObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FeaturesResponseObject',
      type: {
        name: 'Composite',
        className: 'FeaturesResponseObject',
        modelProperties: {
          phraselistFeatures: {
            required: false,
            serializedName: 'phraselistFeatures',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PhraseListFeatureInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'PhraseListFeatureInfo'
                  }
              }
            }
          },
          patternFeatures: {
            required: false,
            serializedName: 'patternFeatures',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PatternFeatureInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'PatternFeatureInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = FeaturesResponseObject;
