/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Intent Classifier.
 *
 * @extends models['ModelInfo']
 */
class IntentClassifier extends models['ModelInfo'] {
  /**
   * Create a IntentClassifier.
   * @property {string} [customPrebuiltDomainName] The domain name.
   * @property {string} [customPrebuiltModelName] The intent name or entity
   * name.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IntentClassifier
   *
   * @returns {object} metadata of IntentClassifier
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Intent Classifier',
      type: {
        name: 'Composite',
        className: 'IntentClassifier',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          typeId: {
            required: false,
            serializedName: 'typeId',
            type: {
              name: 'Number'
            }
          },
          readableType: {
            required: true,
            serializedName: 'readableType',
            type: {
              name: 'String'
            }
          },
          customPrebuiltDomainName: {
            required: false,
            serializedName: 'customPrebuiltDomainName',
            type: {
              name: 'String'
            }
          },
          customPrebuiltModelName: {
            required: false,
            serializedName: 'customPrebuiltModelName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IntentClassifier;
