/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Exported Model - A Pattern feature.
 *
 */
class JSONRegexFeature {
  /**
   * Create a JSONRegexFeature.
   * @property {string} [pattern] The Regular Expression to match.
   * @property {boolean} [activated] Indicates if the Pattern feature is
   * enabled.
   * @property {string} [name] Name of the feature.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JSONRegexFeature
   *
   * @returns {object} metadata of JSONRegexFeature
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JSONRegexFeature',
      type: {
        name: 'Composite',
        className: 'JSONRegexFeature',
        modelProperties: {
          pattern: {
            required: false,
            serializedName: 'pattern',
            type: {
              name: 'String'
            }
          },
          activated: {
            required: false,
            serializedName: 'activated',
            type: {
              name: 'Boolean'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JSONRegexFeature;
