/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Exported Model - Utterance that was used to train the model.
 *
 */
class JSONUtterance {
  /**
   * Create a JSONUtterance.
   * @property {string} [text] The utterance.
   * @property {string} [intent] The matched intent.
   * @property {array} [entities] The matched entities.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JSONUtterance
   *
   * @returns {object} metadata of JSONUtterance
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JSONUtterance',
      type: {
        name: 'Composite',
        className: 'JSONUtterance',
        modelProperties: {
          text: {
            required: false,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          intent: {
            required: false,
            serializedName: 'intent',
            type: {
              name: 'String'
            }
          },
          entities: {
            required: false,
            serializedName: 'entities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JSONEntityElementType',
                  type: {
                    name: 'Composite',
                    className: 'JSONEntity'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JSONUtterance;
