/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Object model for updating an existing Pattern feature.
 *
 */
class PatternUpdateObject {
  /**
   * Create a PatternUpdateObject.
   * @property {string} [pattern] The Regular Expression to match.
   * @property {string} [name] Name of the feature.
   * @property {boolean} [isActive] Indicates if the Pattern feature is
   * enabled. Default value: true .
   */
  constructor() {
  }

  /**
   * Defines the metadata of PatternUpdateObject
   *
   * @returns {object} metadata of PatternUpdateObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PatternUpdateObject',
      type: {
        name: 'Composite',
        className: 'PatternUpdateObject',
        modelProperties: {
          pattern: {
            required: false,
            serializedName: 'pattern',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          isActive: {
            required: false,
            serializedName: 'isActive',
            defaultValue: true,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PatternUpdateObject;
