/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Secrets related to a Machine Learning compute based on AKS.
 *
 * @extends models['ComputeSecrets']
 */
class AksComputeSecrets extends models['ComputeSecrets'] {
  /**
   * Create a AksComputeSecrets.
   * @member {string} [userKubeConfig] Content of kubeconfig file that can be
   * used to connect to the Kubernetes cluster.
   * @member {string} [adminKubeConfig] Content of kubeconfig file that can be
   * used to connect to the Kubernetes cluster.
   * @member {string} [imagePullSecretName] Image registry pull secret.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AksComputeSecrets
   *
   * @returns {object} metadata of AksComputeSecrets
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AKS',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'computeType',
          clientName: 'computeType'
        },
        uberParent: 'ComputeSecrets',
        className: 'AksComputeSecrets',
        modelProperties: {
          computeType: {
            required: true,
            serializedName: 'computeType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          userKubeConfig: {
            required: false,
            serializedName: 'userKubeConfig',
            type: {
              name: 'String'
            }
          },
          adminKubeConfig: {
            required: false,
            serializedName: 'adminKubeConfig',
            type: {
              name: 'String'
            }
          },
          imagePullSecretName: {
            required: false,
            serializedName: 'imagePullSecretName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AksComputeSecrets;
