/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * BatchAI properties
 *
 */
class BatchAIProperties {
  /**
   * Create a BatchAIProperties.
   * @member {string} [vmSize] Virtual Machine Size
   * @member {string} [vmPriority] Virtual Machine priority
   * @member {object} [scaleSettings] Scale settings for BatchAI
   * @member {number} [scaleSettings.maxNodeCount] Max number of nodes to use
   * @member {number} [scaleSettings.minNodeCount] Min number of nodes to use
   * @member {boolean} [scaleSettings.autoScaleEnabled] Enable or disable auto
   * scale
   */
  constructor() {
  }

  /**
   * Defines the metadata of BatchAIProperties
   *
   * @returns {object} metadata of BatchAIProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BatchAI_properties',
      type: {
        name: 'Composite',
        className: 'BatchAIProperties',
        modelProperties: {
          vmSize: {
            required: false,
            serializedName: 'vmSize',
            type: {
              name: 'String'
            }
          },
          vmPriority: {
            required: false,
            serializedName: 'vmPriority',
            type: {
              name: 'String'
            }
          },
          scaleSettings: {
            required: false,
            serializedName: 'scaleSettings',
            type: {
              name: 'Composite',
              className: 'ScaleSettings'
            }
          }
        }
      }
    };
  }
}

module.exports = BatchAIProperties;
