/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Operation supported by the Microsoft.Management resource provider.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] Operation name: {provider}/{resource}/{operation}.
   * @member {object} [display] The object that represents the operation.
   * @member {string} [display.provider] The name of the provider.
   * @member {string} [display.resource] The resource on which the operation is
   * performed.
   * @member {string} [display.operation] The operation that can be performed.
   * @member {string} [display.description] Operation description.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
