/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * this is the management partner operations response
 *
 */
class OperationResponse {
  /**
   * Create a OperationResponse.
   * @member {string} [name] this is the operation response name
   * @member {object} [display] this is the operation display
   * @member {string} [display.provider] the is management partner provider
   * @member {string} [display.resource] the is management partner resource
   * @member {string} [display.operation] the is management partner operation
   * @member {string} [display.description] the is management partner operation
   * description
   * @member {string} [origin] the is operation response origin information
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationResponse
   *
   * @returns {object} metadata of OperationResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationResponse',
      type: {
        name: 'Composite',
        className: 'OperationResponse',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationResponse;
