/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The human-readable description of the operation.
 *
 */
class MapsOperationsValueItemDisplay {
  /**
   * Create a MapsOperationsValueItemDisplay.
   * @member {string} [provider] Service provider: Microsoft Maps.
   * @member {string} [resource] Resource on which the operation is performed.
   * @member {string} [operation] The action that users can perform, based on
   * their permission level.
   * @member {string} [description] The description of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MapsOperationsValueItemDisplay
   *
   * @returns {object} metadata of MapsOperationsValueItemDisplay
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MapsOperations_valueItem_display',
      type: {
        name: 'Composite',
        className: 'MapsOperationsValueItemDisplay',
        modelProperties: {
          provider: {
            required: false,
            readOnly: true,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            readOnly: true,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            readOnly: true,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MapsOperationsValueItemDisplay;
