/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents a log file.
 *
 * @extends models['ProxyResource']
 */
class LogFile extends models['ProxyResource'] {
  /**
   * Create a LogFile.
   * @property {number} [sizeInKB] Size of the log file.
   * @property {date} [createdTime] Creation timestamp of the log file.
   * @property {date} [lastModifiedTime] Last modified timestamp of the log
   * file.
   * @property {string} [logFileType] Type of the log file.
   * @property {string} [url] The url to download the log file from.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LogFile
   *
   * @returns {object} metadata of LogFile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LogFile',
      type: {
        name: 'Composite',
        className: 'LogFile',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          sizeInKB: {
            required: false,
            serializedName: 'properties.sizeInKB',
            type: {
              name: 'Number'
            }
          },
          createdTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.createdTime',
            type: {
              name: 'DateTime'
            }
          },
          lastModifiedTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.lastModifiedTime',
            type: {
              name: 'DateTime'
            }
          },
          logFileType: {
            required: false,
            serializedName: 'properties.type',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            readOnly: true,
            serializedName: 'properties.url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LogFile;
