/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of the Streaming Locator.
 *
 */
class AssetStreamingLocator {
  /**
   * Create a AssetStreamingLocator.
   * @property {string} [name] Streaming Locator name.
   * @property {string} [assetName] Asset Name.
   * @property {date} [created] The creation time of the Streaming Locator.
   * @property {date} [startTime] The start time of the Streaming Locator.
   * @property {date} [endTime] The end time of the Streaming Locator.
   * @property {uuid} [streamingLocatorId] StreamingLocatorId of the Streaming
   * Locator.
   * @property {string} [streamingPolicyName] Name of the Streaming Policy used
   * by this Streaming Locator.
   * @property {string} [defaultContentKeyPolicyName] Name of the default
   * ContentKeyPolicy used by this Streaming Locator.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AssetStreamingLocator
   *
   * @returns {object} metadata of AssetStreamingLocator
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AssetStreamingLocator',
      type: {
        name: 'Composite',
        className: 'AssetStreamingLocator',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          assetName: {
            required: false,
            readOnly: true,
            serializedName: 'assetName',
            type: {
              name: 'String'
            }
          },
          created: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'created',
            type: {
              name: 'DateTime'
            }
          },
          startTime: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          streamingLocatorId: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'streamingLocatorId',
            type: {
              name: 'String'
            }
          },
          streamingPolicyName: {
            required: false,
            readOnly: true,
            serializedName: 'streamingPolicyName',
            type: {
              name: 'String'
            }
          },
          defaultContentKeyPolicyName: {
            required: false,
            readOnly: true,
            serializedName: 'defaultContentKeyPolicyName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AssetStreamingLocator;
