/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents HTTPS job input.
 *
 * @extends models['JobInputClip']
 */
class JobInputHttp extends models['JobInputClip'] {
  /**
   * Create a JobInputHttp.
   * @property {string} [baseUri] Base URI for HTTPS job input. It will be
   * concatenated with provided file names. If no base uri is given, then the
   * provided file list is assumed to be fully qualified uris. Maximum length
   * of 4000 characters.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of JobInputHttp
   *
   * @returns {object} metadata of JobInputHttp
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.JobInputHttp',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '@odata.type',
          clientName: 'odatatype'
        },
        uberParent: 'JobInput',
        className: 'JobInputHttp',
        modelProperties: {
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          files: {
            required: false,
            serializedName: 'files',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          baseUri: {
            required: false,
            serializedName: 'baseUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobInputHttp;
