/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A metric dimension.
 *
 */
class MetricDimension {
  /**
   * Create a MetricDimension.
   * @property {string} [name] The metric dimension name.
   * @property {string} [displayName] The display name for the dimension.
   * @property {boolean} [toBeExportedForShoebox] Whether to export metric to
   * shoebox.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricDimension
   *
   * @returns {object} metadata of MetricDimension
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricDimension',
      type: {
        name: 'Composite',
        className: 'MetricDimension',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            readOnly: true,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          toBeExportedForShoebox: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'toBeExportedForShoebox',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricDimension;
