/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * StreamingEndpoint access control definition.
 *
 */
class StreamingEndpointAccessControl {
  /**
   * Create a StreamingEndpointAccessControl.
   * @property {object} [akamai] The access control of Akamai
   * @property {array} [akamai.akamaiSignatureHeaderAuthenticationKeyList]
   * authentication key list
   * @property {object} [ip] The IP access control of the StreamingEndpoint.
   * @property {array} [ip.allow] The IP allow list.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StreamingEndpointAccessControl
   *
   * @returns {object} metadata of StreamingEndpointAccessControl
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StreamingEndpointAccessControl',
      type: {
        name: 'Composite',
        className: 'StreamingEndpointAccessControl',
        modelProperties: {
          akamai: {
            required: false,
            serializedName: 'akamai',
            type: {
              name: 'Composite',
              className: 'AkamaiAccessControl'
            }
          },
          ip: {
            required: false,
            serializedName: 'ip',
            type: {
              name: 'Composite',
              className: 'IPAccessControl'
            }
          }
        }
      }
    };
  }
}

module.exports = StreamingEndpointAccessControl;
