/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An alert status.
 *
 */
class MetricAlertStatus {
  /**
   * Create a MetricAlertStatus.
   * @property {string} [name] The status name.
   * @property {string} [id] The alert rule arm id.
   * @property {string} [type] The extended resource type name.
   * @property {object} [properties] The alert status properties of the metric
   * alert status.
   * @property {object} [properties.dimensions] An object describing the type
   * of the dimensions.
   * @property {string} [properties.status] status value
   * @property {date} [properties.timestamp] UTC time when the status was
   * checked.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricAlertStatus
   *
   * @returns {object} metadata of MetricAlertStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricAlertStatus',
      type: {
        name: 'Composite',
        className: 'MetricAlertStatus',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'MetricAlertStatusProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricAlertStatus;
