/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A voice receiver.
 *
 */
class VoiceReceiver {
  /**
   * Create a VoiceReceiver.
   * @property {string} name The name of the voice receiver. Names must be
   * unique across all receivers within an action group.
   * @property {string} countryCode The country code of the voice receiver.
   * @property {string} phoneNumber The phone number of the voice receiver.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VoiceReceiver
   *
   * @returns {object} metadata of VoiceReceiver
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VoiceReceiver',
      type: {
        name: 'Composite',
        className: 'VoiceReceiver',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          countryCode: {
            required: true,
            serializedName: 'countryCode',
            type: {
              name: 'String'
            }
          },
          phoneNumber: {
            required: true,
            serializedName: 'phoneNumber',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VoiceReceiver;
