/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a Log Analytics Workspace.
 *
 */
class WorkspaceInfo {
  /**
   * Create a WorkspaceInfo.
   * @property {string} id Azure Resource Manager identifier of the Log
   * Analytics Workspace.
   * @property {string} location Location of the Log Analytics workspace.
   * @property {string} customerId Log Analytics workspace identifier.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkspaceInfo
   *
   * @returns {object} metadata of WorkspaceInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkspaceInfo',
      type: {
        name: 'Composite',
        className: 'WorkspaceInfo',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          customerId: {
            required: true,
            serializedName: 'properties.customerId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkspaceInfo;
