/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Policy definition summary.
 *
 */
class PolicyDefinitionSummary {
  /**
   * Create a PolicyDefinitionSummary.
   * @property {string} [policyDefinitionId] Policy definition ID.
   * @property {string} [policyDefinitionReferenceId] Policy definition
   * reference ID.
   * @property {string} [effect] Policy effect, i.e. policy definition action.
   * @property {object} [results] Non-compliance summary for the policy
   * definition.
   * @property {string} [results.queryResultsUri] HTTP POST URI for
   * queryResults action on Microsoft.PolicyInsights to retrieve raw results
   * for the non-compliance summary.
   * @property {number} [results.nonCompliantResources] Number of non-compliant
   * resources.
   * @property {number} [results.nonCompliantPolicies] Number of non-compliant
   * policies.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PolicyDefinitionSummary
   *
   * @returns {object} metadata of PolicyDefinitionSummary
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PolicyDefinitionSummary',
      type: {
        name: 'Composite',
        className: 'PolicyDefinitionSummary',
        modelProperties: {
          policyDefinitionId: {
            required: false,
            serializedName: 'policyDefinitionId',
            type: {
              name: 'String'
            }
          },
          policyDefinitionReferenceId: {
            required: false,
            serializedName: 'policyDefinitionReferenceId',
            type: {
              name: 'String'
            }
          },
          effect: {
            required: false,
            serializedName: 'effect',
            type: {
              name: 'String'
            }
          },
          results: {
            required: false,
            serializedName: 'results',
            type: {
              name: 'Composite',
              className: 'SummaryResults'
            }
          }
        }
      }
    };
  }
}

module.exports = PolicyDefinitionSummary;
