/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The deployment status summary for all deployments created by the
 * remediation.
 *
 */
class RemediationDeploymentSummary {
  /**
   * Create a RemediationDeploymentSummary.
   * @property {number} [totalDeployments] The number of deployments required
   * by the remediation.
   * @property {number} [successfulDeployments] The number of deployments
   * required by the remediation that have succeeded.
   * @property {number} [failedDeployments] The number of deployments required
   * by the remediation that have failed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RemediationDeploymentSummary
   *
   * @returns {object} metadata of RemediationDeploymentSummary
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RemediationDeploymentSummary',
      type: {
        name: 'Composite',
        className: 'RemediationDeploymentSummary',
        modelProperties: {
          totalDeployments: {
            required: false,
            serializedName: 'totalDeployments',
            type: {
              name: 'Number'
            }
          },
          successfulDeployments: {
            required: false,
            serializedName: 'successfulDeployments',
            type: {
              name: 'Number'
            }
          },
          failedDeployments: {
            required: false,
            serializedName: 'failedDeployments',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RemediationDeploymentSummary;
