/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Extended information of the container.
 *
 */
class AzureWorkloadContainerExtendedInfo {
  /**
   * Create a AzureWorkloadContainerExtendedInfo.
   * @member {string} [hostServerName] Host Os Name in case of Stand Alone and
   * Cluster Name in case of distributed container.
   * @member {object} [inquiryInfo] Inquiry Status for the container.
   * @member {string} [inquiryInfo.status] Inquiry Status for this container
   * such as
   * InProgress | Failed | Succeeded
   * @member {object} [inquiryInfo.errorDetail] Error Details if the Status is
   * non-success.
   * @member {string} [inquiryInfo.errorDetail.code] Error code.
   * @member {string} [inquiryInfo.errorDetail.message] Error Message related
   * to the Code.
   * @member {array} [inquiryInfo.errorDetail.recommendations] List of
   * recommendation strings.
   * @member {array} [inquiryInfo.inquiryDetails] Inquiry Details which will
   * have workload specific details.
   * For e.g. - For SQL and oracle this will contain different details.
   * @member {array} [nodesList] List of the nodes in case of distributed
   * container.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureWorkloadContainerExtendedInfo
   *
   * @returns {object} metadata of AzureWorkloadContainerExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureWorkloadContainerExtendedInfo',
      type: {
        name: 'Composite',
        className: 'AzureWorkloadContainerExtendedInfo',
        modelProperties: {
          hostServerName: {
            required: false,
            serializedName: 'hostServerName',
            type: {
              name: 'String'
            }
          },
          inquiryInfo: {
            required: false,
            serializedName: 'inquiryInfo',
            type: {
              name: 'Composite',
              className: 'InquiryInfo'
            }
          },
          nodesList: {
            required: false,
            serializedName: 'nodesList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DistributedNodesInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'DistributedNodesInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureWorkloadContainerExtendedInfo;
