/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Container extended information
 *
 */
class GenericContainerExtendedInfo {
  /**
   * Create a GenericContainerExtendedInfo.
   * @member {string} [rawCertData] Public key of container cert
   * @member {object} [containerIdentityInfo] Container identity information
   * @member {string} [containerIdentityInfo.uniqueName] Unique name of the
   * container
   * @member {string} [containerIdentityInfo.aadTenantId] Protection container
   * identity - AAD Tenant
   * @member {string} [containerIdentityInfo.servicePrincipalClientId]
   * Protection container identity - AAD Service Principal
   * @member {string} [containerIdentityInfo.audience] Protection container
   * identity - Audience
   * @member {object} [serviceEndpoints] Azure Backup Service Endpoints for the
   * container
   */
  constructor() {
  }

  /**
   * Defines the metadata of GenericContainerExtendedInfo
   *
   * @returns {object} metadata of GenericContainerExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GenericContainerExtendedInfo',
      type: {
        name: 'Composite',
        className: 'GenericContainerExtendedInfo',
        modelProperties: {
          rawCertData: {
            required: false,
            serializedName: 'rawCertData',
            type: {
              name: 'String'
            }
          },
          containerIdentityInfo: {
            required: false,
            serializedName: 'containerIdentityInfo',
            type: {
              name: 'Composite',
              className: 'ContainerIdentityInfo'
            }
          },
          serviceEndpoints: {
            required: false,
            serializedName: 'serviceEndpoints',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = GenericContainerExtendedInfo;
