/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Log policy schedule.
 *
 * @extends models['SchedulePolicy']
 */
class LogSchedulePolicy extends models['SchedulePolicy'] {
  /**
   * Create a LogSchedulePolicy.
   * @member {number} [scheduleFrequencyInMins] Frequency of the log schedule
   * operation of this policy in minutes.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LogSchedulePolicy
   *
   * @returns {object} metadata of LogSchedulePolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LogSchedulePolicy',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'schedulePolicyType',
          clientName: 'schedulePolicyType'
        },
        uberParent: 'SchedulePolicy',
        className: 'LogSchedulePolicy',
        modelProperties: {
          schedulePolicyType: {
            required: true,
            serializedName: 'schedulePolicyType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          scheduleFrequencyInMins: {
            required: false,
            serializedName: 'scheduleFrequencyInMins',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = LogSchedulePolicy;
