/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Pre-backup validation for Azure VM Workload provider.
 *
 */
class PreBackupValidation {
  /**
   * Create a PreBackupValidation.
   * @member {string} [status] Status of protectable item, i.e.
   * InProgress,Succeeded,Failed. Possible values include: 'Invalid',
   * 'Success', 'Failed'
   * @member {string} [code] Error code of protectable item
   * @member {string} [message] Message corresponding to the error code for the
   * protectable item
   */
  constructor() {
  }

  /**
   * Defines the metadata of PreBackupValidation
   *
   * @returns {object} metadata of PreBackupValidation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PreBackupValidation',
      type: {
        name: 'Composite',
        className: 'PreBackupValidation',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PreBackupValidation;
