/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Filters to list protection intent.
 *
 */
class ProtectionIntentQueryObject {
  /**
   * Create a ProtectionIntentQueryObject.
   * @member {string} [backupManagementType] Backup management type for the
   * backed up item. Possible values include: 'Invalid', 'AzureIaasVM', 'MAB',
   * 'DPM', 'AzureBackupServer', 'AzureSql', 'AzureStorage', 'AzureWorkload',
   * 'DefaultBackup'
   * @member {string} [itemType] Type of workload this item represents.
   * Possible values include: 'Invalid', 'SQLInstance',
   * 'SQLAvailabilityGroupContainer'
   * @member {string} [parentName] Parent name of the intent
   * @member {string} [itemName] Item name of the intent
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProtectionIntentQueryObject
   *
   * @returns {object} metadata of ProtectionIntentQueryObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectionIntentQueryObject',
      type: {
        name: 'Composite',
        className: 'ProtectionIntentQueryObject',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          itemType: {
            required: false,
            serializedName: 'itemType',
            type: {
              name: 'String'
            }
          },
          parentName: {
            required: false,
            serializedName: 'parentName',
            type: {
              name: 'String'
            }
          },
          itemName: {
            required: false,
            serializedName: 'itemName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectionIntentQueryObject;
