/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details about target workload during restore operation.
 *
 */
class TargetRestoreInfo {
  /**
   * Create a TargetRestoreInfo.
   * @member {string} [overwriteOption] Can Overwrite if Target DataBase
   * already exists. Possible values include: 'Invalid', 'FailOnConflict',
   * 'Overwrite'
   * @member {string} [containerId] Resource Id name of the container in which
   * Target DataBase resides
   * @member {string} [databaseName] Database name InstanceName/DataBaseName
   * for SQL or System/DbName for SAP Hana
   */
  constructor() {
  }

  /**
   * Defines the metadata of TargetRestoreInfo
   *
   * @returns {object} metadata of TargetRestoreInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TargetRestoreInfo',
      type: {
        name: 'Composite',
        className: 'TargetRestoreInfo',
        modelProperties: {
          overwriteOption: {
            required: false,
            serializedName: 'overwriteOption',
            type: {
              name: 'String'
            }
          },
          containerId: {
            required: false,
            serializedName: 'containerId',
            type: {
              name: 'String'
            }
          },
          databaseName: {
            required: false,
            serializedName: 'databaseName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TargetRestoreInfo;
