/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of the vault.
 *
 */
class VaultProperties {
  /**
   * Create a VaultProperties.
   * @property {string} [provisioningState] Provisioning State.
   * @property {object} [upgradeDetails]
   * @property {string} [upgradeDetails.operationId] ID of the vault upgrade
   * operation.
   * @property {date} [upgradeDetails.startTimeUtc] UTC time at which the
   * upgrade operation has started.
   * @property {date} [upgradeDetails.lastUpdatedTimeUtc] UTC time at which the
   * upgrade operation status was last updated.
   * @property {date} [upgradeDetails.endTimeUtc] UTC time at which the upgrade
   * operation has ended.
   * @property {string} [upgradeDetails.status] Status of the vault upgrade
   * operation. Possible values include: 'Unknown', 'InProgress', 'Upgraded',
   * 'Failed'
   * @property {string} [upgradeDetails.message] Message to the user containing
   * information about the upgrade operation.
   * @property {string} [upgradeDetails.triggerType] The way the vault upgrade
   * was triggered. Possible values include: 'UserTriggered', 'ForcedUpgrade'
   * @property {string} [upgradeDetails.upgradedResourceId] Resource ID of the
   * upgraded vault.
   * @property {string} [upgradeDetails.previousResourceId] Resource ID of the
   * vault before the upgrade.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VaultProperties
   *
   * @returns {object} metadata of VaultProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VaultProperties',
      type: {
        name: 'Composite',
        className: 'VaultProperties',
        modelProperties: {
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'provisioningState',
            type: {
              name: 'String'
            }
          },
          upgradeDetails: {
            required: false,
            serializedName: 'upgradeDetails',
            type: {
              name: 'Composite',
              className: 'UpgradeDetails'
            }
          }
        }
      }
    };
  }
}

module.exports = VaultProperties;
