/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Configure pairing input properties.
 *
 */
class CreateProtectionContainerMappingInputProperties {
  /**
   * Create a CreateProtectionContainerMappingInputProperties.
   * @member {string} [targetProtectionContainerId] The target unique
   * protection container name.
   * @member {string} [policyId] Applicable policy.
   * @member {object} [providerSpecificInput] Provider specific input for
   * pairing.
   * @member {string} [providerSpecificInput.instanceType] Polymorphic
   * Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateProtectionContainerMappingInputProperties
   *
   * @returns {object} metadata of CreateProtectionContainerMappingInputProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateProtectionContainerMappingInputProperties',
      type: {
        name: 'Composite',
        className: 'CreateProtectionContainerMappingInputProperties',
        modelProperties: {
          targetProtectionContainerId: {
            required: false,
            serializedName: 'targetProtectionContainerId',
            type: {
              name: 'String'
            }
          },
          policyId: {
            required: false,
            serializedName: 'policyId',
            type: {
              name: 'String'
            }
          },
          providerSpecificInput: {
            required: false,
            serializedName: 'providerSpecificInput',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'ReplicationProviderSpecificContainerMappingInput',
              className: 'ReplicationProviderSpecificContainerMappingInput'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateProtectionContainerMappingInputProperties;
