/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Disk Encryption Key Information (BitLocker Encryption Key (BEK) on Windows).
 *
 */
class DiskEncryptionKeyInfo {
  /**
   * Create a DiskEncryptionKeyInfo.
   * @member {string} [secretIdentifier] The secret url / identifier.
   * @member {string} [keyVaultResourceArmId] The KeyVault resource ARM id for
   * secret.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiskEncryptionKeyInfo
   *
   * @returns {object} metadata of DiskEncryptionKeyInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiskEncryptionKeyInfo',
      type: {
        name: 'Composite',
        className: 'DiskEncryptionKeyInfo',
        modelProperties: {
          secretIdentifier: {
            required: false,
            serializedName: 'secretIdentifier',
            type: {
              name: 'String'
            }
          },
          keyVaultResourceArmId: {
            required: false,
            serializedName: 'keyVaultResourceArmId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DiskEncryptionKeyInfo;
