/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * InMage agent version details.
 *
 */
class InMageAgentVersionDetails {
  /**
   * Create a InMageAgentVersionDetails.
   * @member {string} [postUpdateRebootStatus] A value indicating whether
   * reboot is required after update is applied.
   * @member {string} [version] The agent version.
   * @member {date} [expiryDate] Version expiry date.
   * @member {string} [status] A value indicating whether security update
   * required. Possible values include: 'Supported', 'NotSupported',
   * 'Deprecated', 'UpdateRequired', 'SecurityUpdateRequired'
   */
  constructor() {
  }

  /**
   * Defines the metadata of InMageAgentVersionDetails
   *
   * @returns {object} metadata of InMageAgentVersionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InMageAgentVersionDetails',
      type: {
        name: 'Composite',
        className: 'InMageAgentVersionDetails',
        modelProperties: {
          postUpdateRebootStatus: {
            required: false,
            serializedName: 'postUpdateRebootStatus',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          expiryDate: {
            required: false,
            serializedName: 'expiryDate',
            type: {
              name: 'DateTime'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = InMageAgentVersionDetails;
