/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Key Encryption Key (KEK) information.
 *
 */
class KeyEncryptionKeyInfo {
  /**
   * Create a KeyEncryptionKeyInfo.
   * @member {string} [keyIdentifier] The key url / identifier.
   * @member {string} [keyVaultResourceArmId] The KeyVault resource ARM id for
   * key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyEncryptionKeyInfo
   *
   * @returns {object} metadata of KeyEncryptionKeyInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyEncryptionKeyInfo',
      type: {
        name: 'Composite',
        className: 'KeyEncryptionKeyInfo',
        modelProperties: {
          keyIdentifier: {
            required: false,
            serializedName: 'keyIdentifier',
            type: {
              name: 'String'
            }
          },
          keyVaultResourceArmId: {
            required: false,
            serializedName: 'keyVaultResourceArmId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyEncryptionKeyInfo;
