/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Fabric provider specific settings.
 *
 * @extends models['FabricSpecificCreationInput']
 */
class VMwareV2FabricCreationInput extends models['FabricSpecificCreationInput'] {
  /**
   * Create a VMwareV2FabricCreationInput.
   * @member {string} [keyVaultUrl] The Key Vault URL.
   * @member {string} [keyVaultResourceArmId] The Key Vault ARM Id.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VMwareV2FabricCreationInput
   *
   * @returns {object} metadata of VMwareV2FabricCreationInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VMwareV2',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'instanceType',
          clientName: 'instanceType'
        },
        uberParent: 'FabricSpecificCreationInput',
        className: 'VMwareV2FabricCreationInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          keyVaultUrl: {
            required: false,
            serializedName: 'keyVaultUrl',
            type: {
              name: 'String'
            }
          },
          keyVaultResourceArmId: {
            required: false,
            serializedName: 'keyVaultResourceArmId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VMwareV2FabricCreationInput;
