/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a SkuRestriction.
 */
class SkuRestriction {
  /**
   * Create a SkuRestriction.
   * @property {string} [type] The type of restrictions.
   * @property {array} [values] The value of restrictions. If the restriction
   * type is set to location. This would be different locations where the SKU
   * is restricted.
   * @property {string} [reasonCode] The reason for restriction.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SkuRestriction
   *
   * @returns {object} metadata of SkuRestriction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SkuRestriction',
      type: {
        name: 'Composite',
        className: 'SkuRestriction',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          values: {
            required: false,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          reasonCode: {
            required: false,
            serializedName: 'reasonCode',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SkuRestriction;
