/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The resource link.
 *
 * @extends models['BaseResource']
 */
class ResourceLink extends models['BaseResource'] {
  /**
   * Create a ResourceLink.
   * @property {string} [id] The fully qualified ID of the resource link.
   * @property {string} [name] The name of the resource link.
   * @property {object} [type] The resource link object.
   * @property {object} [properties] Properties for resource link.
   * @property {string} [properties.sourceId] The fully qualified ID of the
   * source resource in the link.
   * @property {string} [properties.targetId] The fully qualified ID of the
   * target resource in the link.
   * @property {string} [properties.notes] Notes about the resource link.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ResourceLink
   *
   * @returns {object} metadata of ResourceLink
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceLink',
      type: {
        name: 'Composite',
        className: 'ResourceLink',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'Object'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'ResourceLinkProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceLink;
