/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Resource type managed by the resource provider.
 *
 */
class ProviderResourceType {
  /**
   * Create a ProviderResourceType.
   * @property {string} [resourceType] The resource type.
   * @property {array} [locations] The collection of locations where this
   * resource type can be created.
   * @property {array} [aliases] The aliases that are supported by this
   * resource type.
   * @property {array} [apiVersions] The API version.
   * @property {object} [properties] The properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProviderResourceType
   *
   * @returns {object} metadata of ProviderResourceType
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProviderResourceType',
      type: {
        name: 'Composite',
        className: 'ProviderResourceType',
        modelProperties: {
          resourceType: {
            required: false,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          locations: {
            required: false,
            serializedName: 'locations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          aliases: {
            required: false,
            serializedName: 'aliases',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AliasTypeElementType',
                  type: {
                    name: 'Composite',
                    className: 'AliasType'
                  }
              }
            }
          },
          apiVersions: {
            required: false,
            serializedName: 'apiVersions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ProviderResourceType;
