/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a REST API operation.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] The name of the operation. This name is of the
   * form {provider}/{resource}/{operation}.
   * @member {object} [display] The object that describes the operation.
   * @member {string} [display.provider] The friendly name of the resource
   * provider.
   * @member {string} [display.operation] The operation type: read, write,
   * delete, listKeys/action, etc.
   * @member {string} [display.resource] The resource type on which the
   * operation is performed.
   * @member {string} [display.description] The friendly name of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            readOnly: true,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
