/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Auto provisioning setting
 *
 * @extends models['Resource']
 */
class AutoProvisioningSetting extends models['Resource'] {
  /**
   * Create a AutoProvisioningSetting.
   * @member {string} autoProvision Describes what kind of security agent
   * provisioning action to take. Possible values include: 'On', 'Off'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AutoProvisioningSetting
   *
   * @returns {object} metadata of AutoProvisioningSetting
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutoProvisioningSetting',
      type: {
        name: 'Composite',
        className: 'AutoProvisioningSetting',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          autoProvision: {
            required: true,
            serializedName: 'properties.autoProvision',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AutoProvisioningSetting;
