/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information protection policy.
 *
 * @extends models['Resource']
 */
class InformationProtectionPolicy extends models['Resource'] {
  /**
   * Create a InformationProtectionPolicy.
   * @member {date} [lastModifiedUtc] Describes the last UTC time the policy
   * was modified.
   * @member {object} [labels] Dictionary of sensitivity labels.
   * @member {object} [informationTypes] The sensitivity information types.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of InformationProtectionPolicy
   *
   * @returns {object} metadata of InformationProtectionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InformationProtectionPolicy',
      type: {
        name: 'Composite',
        className: 'InformationProtectionPolicy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          lastModifiedUtc: {
            required: false,
            readOnly: true,
            serializedName: 'properties.lastModifiedUtc',
            type: {
              name: 'DateTime'
            }
          },
          labels: {
            required: false,
            serializedName: 'properties.labels',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'SensitivityLabelElementType',
                  type: {
                    name: 'Composite',
                    className: 'SensitivityLabel'
                  }
              }
            }
          },
          informationTypes: {
            required: false,
            serializedName: 'properties.informationTypes',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'InformationTypeElementType',
                  type: {
                    name: 'Composite',
                    className: 'InformationType'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = InformationProtectionPolicy;
