/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The sensitivity label.
 *
 */
class SensitivityLabel {
  /**
   * Create a SensitivityLabel.
   * @member {string} [displayName] The name of the sensitivity label.
   * @member {number} [order] The order of the sensitivity label.
   * @member {boolean} [enabled] Indicates whether the label is enabled or not.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SensitivityLabel
   *
   * @returns {object} metadata of SensitivityLabel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SensitivityLabel',
      type: {
        name: 'Composite',
        className: 'SensitivityLabel',
        modelProperties: {
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          order: {
            required: false,
            serializedName: 'order',
            type: {
              name: 'Number'
            }
          },
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = SensitivityLabel;
