/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Subscription settings list.
 */
class SettingsList extends Array {
  /**
   * Create a SettingsList.
   * @member {string} [nextLink] The URI to fetch the next page.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SettingsList
   *
   * @returns {object} metadata of SettingsList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SettingsList',
      type: {
        name: 'Composite',
        className: 'SettingsList',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SettingElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: 'kind',
                      clientName: 'kind'
                    },
                    uberParent: 'Setting',
                    className: 'Setting'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            readOnly: true,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SettingsList;
