/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Chaos Move Primary Fault Scheduled event.
 *
 * @extends models['PartitionEvent']
 */
class ChaosPartitionPrimaryMoveScheduledEvent extends models['PartitionEvent'] {
  /**
   * Create a ChaosPartitionPrimaryMoveScheduledEvent.
   * @property {uuid} faultGroupId Id of fault group.
   * @property {uuid} faultId Id of fault.
   * @property {string} serviceName Service name.
   * @property {string} nodeTo The name of a Service Fabric node.
   * @property {boolean} forcedMove Indicates a forced move.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ChaosPartitionPrimaryMoveScheduledEvent
   *
   * @returns {object} metadata of ChaosPartitionPrimaryMoveScheduledEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ChaosPartitionPrimaryMoveScheduled',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ChaosPartitionPrimaryMoveScheduledEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'Category',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: true,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          },
          faultGroupId: {
            required: true,
            serializedName: 'FaultGroupId',
            type: {
              name: 'String'
            }
          },
          faultId: {
            required: true,
            serializedName: 'FaultId',
            type: {
              name: 'String'
            }
          },
          serviceName: {
            required: true,
            serializedName: 'ServiceName',
            type: {
              name: 'String'
            }
          },
          nodeTo: {
            required: true,
            serializedName: 'NodeTo',
            type: {
              name: 'String'
            }
          },
          forcedMove: {
            required: true,
            serializedName: 'ForcedMove',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ChaosPartitionPrimaryMoveScheduledEvent;
