/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about service type deployed on a node, information such as the
 * status of the service type registration on a node.
 *
 */
class DeployedServiceTypeInfo {
  /**
   * Create a DeployedServiceTypeInfo.
   * @property {string} [serviceTypeName] Name of the service type as specified
   * in the service manifest.
   * @property {string} [serviceManifestName] The name of the service manifest
   * in which this service type is defined.
   * @property {string} [codePackageName] The name of the code package that
   * registered the service type.
   * @property {string} [status] The status of the service type registration on
   * the node. Possible values include: 'Invalid', 'Disabled', 'Enabled',
   * 'Registered'
   * @property {string} [servicePackageActivationId] The ActivationId of a
   * deployed service package. If ServicePackageActivationMode specified at the
   * time of creating the service
   * is 'SharedProcess' (or if it is not specified, in which case it defaults
   * to 'SharedProcess'), then value of ServicePackageActivationId
   * is always an empty string.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeployedServiceTypeInfo
   *
   * @returns {object} metadata of DeployedServiceTypeInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeployedServiceTypeInfo',
      type: {
        name: 'Composite',
        className: 'DeployedServiceTypeInfo',
        modelProperties: {
          serviceTypeName: {
            required: false,
            serializedName: 'ServiceTypeName',
            type: {
              name: 'String'
            }
          },
          serviceManifestName: {
            required: false,
            serializedName: 'ServiceManifestName',
            type: {
              name: 'String'
            }
          },
          codePackageName: {
            required: false,
            serializedName: 'CodePackageName',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'Status',
            type: {
              name: 'String'
            }
          },
          servicePackageActivationId: {
            required: false,
            serializedName: 'ServicePackageActivationId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeployedServiceTypeInfo;
