/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * It describes the body parameters while disabling backup of a backup
 * entity(Application/Service/Partition).
 *
 */
class DisableBackupDescription {
  /**
   * Create a DisableBackupDescription.
   * @property {boolean} cleanBackup Boolean flag to delete backups. It can be
   * set to true for deleting all the backups which were created for the backup
   * entity that is getting disabled for backup.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DisableBackupDescription
   *
   * @returns {object} metadata of DisableBackupDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DisableBackupDescription',
      type: {
        name: 'Composite',
        className: 'DisableBackupDescription',
        modelProperties: {
          cleanBackup: {
            required: true,
            serializedName: 'CleanBackup',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DisableBackupDescription;
