/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a image store folder. It includes how many files this
 * folder contains and its image store relative path.
 *
 */
class FolderInfo {
  /**
   * Create a FolderInfo.
   * @property {string} [storeRelativePath] The remote location within image
   * store. This path is relative to the image store root.
   * @property {string} [fileCount] The number of files from within the image
   * store folder.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FolderInfo
   *
   * @returns {object} metadata of FolderInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FolderInfo',
      type: {
        name: 'Composite',
        className: 'FolderInfo',
        modelProperties: {
          storeRelativePath: {
            required: false,
            serializedName: 'StoreRelativePath',
            type: {
              name: 'String'
            }
          },
          fileCount: {
            required: false,
            serializedName: 'FileCount',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FolderInfo;
