/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes header information for http route matching.
 *
 */
class HttpRouteMatchHeader {
  /**
   * Create a HttpRouteMatchHeader.
   * @property {string} name Name of header to match in request.
   * @property {string} [value] Value of header to match in request.
   * @property {string} [type] how to match header value. Possible values
   * include: 'exact'
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpRouteMatchHeader
   *
   * @returns {object} metadata of HttpRouteMatchHeader
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpRouteMatchHeader',
      type: {
        name: 'Composite',
        className: 'HttpRouteMatchHeader',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HttpRouteMatchHeader;
