/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This type describes a network resource.
 *
 */
class NetworkResourceDescription {
  /**
   * Create a NetworkResourceDescription.
   * @property {string} name Name of the Network resource.
   * @property {object} properties Describes properties of a network resource.
   * @property {string} [properties.description] User readable description of
   * the network.
   * @property {string} [properties.status] Status of the network. Possible
   * values include: 'Unknown', 'Ready', 'Upgrading', 'Creating', 'Deleting',
   * 'Failed'
   * @property {string} [properties.statusDetails] Gives additional information
   * about the current status of the network.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkResourceDescription
   *
   * @returns {object} metadata of NetworkResourceDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkResourceDescription',
      type: {
        name: 'Composite',
        className: 'NetworkResourceDescription',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'kind',
                clientName: 'kind'
              },
              uberParent: 'NetworkResourcePropertiesBase',
              className: 'NetworkResourceProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkResourceDescription;
