/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a Service Fabric property value of type String.
 *
 * @extends models['PropertyValue']
 */
class StringPropertyValue extends models['PropertyValue'] {
  /**
   * Create a StringPropertyValue.
   * @property {string} data The data of the property value.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StringPropertyValue
   *
   * @returns {object} metadata of StringPropertyValue
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'String',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'PropertyValue',
        className: 'StringPropertyValue',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          data: {
            required: true,
            serializedName: 'Data',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StringPropertyValue;
