/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes parameters for creating application-scoped volumes.
 *
 */
class ApplicationScopedVolumeCreationParameters {
  /**
   * Create a ApplicationScopedVolumeCreationParameters.
   * @member {string} [description] User readable description of the volume.
   * @member {string} kind Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationScopedVolumeCreationParameters
   *
   * @returns {object} metadata of ApplicationScopedVolumeCreationParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationScopedVolumeCreationParameters',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'ApplicationScopedVolumeCreationParameters',
        className: 'ApplicationScopedVolumeCreationParameters',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationScopedVolumeCreationParameters;
