/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An operation available at the listed Azure resource provider.
 *
 */
class AvailableOperationDisplay {
  /**
   * Create a AvailableOperationDisplay.
   * @member {string} [provider] Name of the operation provider.
   * @member {string} [resource] Name of the resource on which the operation is
   * available.
   * @member {string} [operation] Name of the available operation.
   * @member {string} [description] Description of the available operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AvailableOperationDisplay
   *
   * @returns {object} metadata of AvailableOperationDisplay
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AvailableOperationDisplay',
      type: {
        name: 'Composite',
        className: 'AvailableOperationDisplay',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AvailableOperationDisplay;
