/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes destination endpoint for routing traffic.
 *
 */
class GatewayDestination {
  /**
   * Create a GatewayDestination.
   * @member {string} applicationName Name of the service fabric Mesh
   * application.
   * @member {string} serviceName service that contains the endpoint.
   * @member {string} endpointName name of the endpoint in the service.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GatewayDestination
   *
   * @returns {object} metadata of GatewayDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GatewayDestination',
      type: {
        name: 'Composite',
        className: 'GatewayDestination',
        modelProperties: {
          applicationName: {
            required: true,
            serializedName: 'applicationName',
            type: {
              name: 'String'
            }
          },
          serviceName: {
            required: true,
            serializedName: 'serviceName',
            type: {
              name: 'String'
            }
          },
          endpointName: {
            required: true,
            serializedName: 'endpointName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GatewayDestination;
