/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes properties of a network resource.
 *
 * @extends models['NetworkResourcePropertiesBase']
 */
class NetworkResourceProperties extends models['NetworkResourcePropertiesBase'] {
  /**
   * Create a NetworkResourceProperties.
   * @member {string} [description] User readable description of the network.
   * @member {string} [status] Status of the network. Possible values include:
   * 'Unknown', 'Ready', 'Upgrading', 'Creating', 'Deleting', 'Failed'
   * @member {string} [statusDetails] Gives additional information about the
   * current status of the network.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NetworkResourceProperties
   *
   * @returns {object} metadata of NetworkResourceProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkResourceProperties',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'ProvisionedResourceProperties',
        className: 'NetworkResourceProperties',
        modelProperties: {
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'provisioningState',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          statusDetails: {
            required: false,
            readOnly: true,
            serializedName: 'statusDetails',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkResourceProperties;
