/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This type describes a value of a secret resource. The name of this resource
 * is the version identifier corresponding to this secret value.
 *
 * @extends models['TrackedResource']
 */
class SecretValueResourceDescription extends models['TrackedResource'] {
  /**
   * Create a SecretValueResourceDescription.
   * @member {string} [provisioningState] State of the resource.
   * @member {string} [value] The actual value of the secret.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SecretValueResourceDescription
   *
   * @returns {object} metadata of SecretValueResourceDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecretValueResourceDescription',
      type: {
        name: 'Composite',
        className: 'SecretValueResourceDescription',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'properties.value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecretValueResourceDescription;
