/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This type describes a volume provided by an Azure Files file share.
 *
 */
class VolumeProviderParametersAzureFile {
  /**
   * Create a VolumeProviderParametersAzureFile.
   * @member {string} accountName Name of the Azure storage account for the
   * File Share.
   * @member {string} [accountKey] Access key of the Azure storage account for
   * the File Share.
   * @member {string} shareName Name of the Azure Files file share that
   * provides storage for the volume.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VolumeProviderParametersAzureFile
   *
   * @returns {object} metadata of VolumeProviderParametersAzureFile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VolumeProviderParametersAzureFile',
      type: {
        name: 'Composite',
        className: 'VolumeProviderParametersAzureFile',
        modelProperties: {
          accountName: {
            required: true,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          accountKey: {
            required: false,
            serializedName: 'accountKey',
            type: {
              name: 'String'
            }
          },
          shareName: {
            required: true,
            serializedName: 'shareName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VolumeProviderParametersAzureFile;
