/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the hosting configuration of a process when hosted on azure
 *
 * @extends models['ProcessHostingConfiguration']
 */
class AzureProcessHostingConfiguration extends models['ProcessHostingConfiguration'] {
  /**
   * Create a AzureProcessHostingConfiguration.
   * @member {object} [cloudService] Contains information about the cloud
   * service the process belongs to
   * @member {string} [cloudService.name] Cloud Service name
   * @member {string} [cloudService.instanceId] Cloud Service instance
   * identifier
   * @member {string} [cloudService.deployment] Cloud Service deployment
   * identifier
   * @member {string} [cloudService.roleName] Cloud Service role name
   * @member {string} [cloudService.roleType] Used to specify type of an Azure
   * Cloud Service role. Possible values include: 'unknown', 'worker', 'web'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureProcessHostingConfiguration
   *
   * @returns {object} metadata of AzureProcessHostingConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'provider:azure',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'ProcessHostingConfiguration',
        className: 'AzureProcessHostingConfiguration',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          cloudService: {
            required: false,
            serializedName: 'cloudService',
            type: {
              name: 'Composite',
              className: 'AzureCloudServiceConfiguration'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureProcessHostingConfiguration;
