/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Reference to a client group.
 *
 * @extends models['ResourceReference']
 */
class ClientGroupReference extends models['ResourceReference'] {
  /**
   * Create a ClientGroupReference.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ClientGroupReference
   *
   * @returns {object} metadata of ClientGroupReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ref:clientgroup',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'ResourceReference',
        className: 'ClientGroupReference',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClientGroupReference;
