/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Resource = require('./resource');
exports.ResourceReference = require('./resourceReference');
exports.MachineReference = require('./machineReference');
exports.ProcessReference = require('./processReference');
exports.PortReference = require('./portReference');
exports.MachineReferenceWithHints = require('./machineReferenceWithHints');
exports.ClientGroupReference = require('./clientGroupReference');
exports.CoreResource = require('./coreResource');
exports.Timezone = require('./timezone');
exports.AgentConfiguration = require('./agentConfiguration');
exports.MachineResourcesConfiguration = require('./machineResourcesConfiguration');
exports.Ipv4NetworkInterface = require('./ipv4NetworkInterface');
exports.Ipv6NetworkInterface = require('./ipv6NetworkInterface');
exports.NetworkConfiguration = require('./networkConfiguration');
exports.OperatingSystemConfiguration = require('./operatingSystemConfiguration');
exports.VirtualMachineConfiguration = require('./virtualMachineConfiguration');
exports.HypervisorConfiguration = require('./hypervisorConfiguration');
exports.HostingConfiguration = require('./hostingConfiguration');
exports.Machine = require('./machine');
exports.ProcessHostedService = require('./processHostedService');
exports.ProcessDetails = require('./processDetails');
exports.ProcessUser = require('./processUser');
exports.ProcessHostingConfiguration = require('./processHostingConfiguration');
exports.Process = require('./process');
exports.Port = require('./port');
exports.ClientGroup = require('./clientGroup');
exports.ClientGroupMember = require('./clientGroupMember');
exports.MachineGroup = require('./machineGroup');
exports.Summary = require('./summary');
exports.MachineCountsByOperatingSystem = require('./machineCountsByOperatingSystem');
exports.MachinesSummary = require('./machinesSummary');
exports.Relationship = require('./relationship');
exports.Connection = require('./connection');
exports.Acceptor = require('./acceptor');
exports.SummaryProperties = require('./summaryProperties');
exports.RelationshipProperties = require('./relationshipProperties');
exports.ImageConfiguration = require('./imageConfiguration');
exports.AzureCloudServiceConfiguration = require('./azureCloudServiceConfiguration');
exports.AzureVmScaleSetConfiguration = require('./azureVmScaleSetConfiguration');
exports.AzureServiceFabricClusterConfiguration = require('./azureServiceFabricClusterConfiguration');
exports.AzureHostingConfiguration = require('./azureHostingConfiguration');
exports.AzureProcessHostingConfiguration = require('./azureProcessHostingConfiguration');
exports.MapNodes = require('./mapNodes');
exports.MapEdges = require('./mapEdges');
exports.Map = require('./map');
exports.Liveness = require('./liveness');
exports.MapRequest = require('./mapRequest');
exports.SingleMachineDependencyMapRequest = require('./singleMachineDependencyMapRequest');
exports.MultipleMachinesMapRequest = require('./multipleMachinesMapRequest');
exports.MachineListMapRequest = require('./machineListMapRequest');
exports.MachineGroupMapRequest = require('./machineGroupMapRequest');
exports.MapResponse = require('./mapResponse');
exports.ClientGroupMembersCount = require('./clientGroupMembersCount');
exports.ErrorModel = require('./errorModel');
exports.ErrorResponse = require('./errorResponse');
exports.MachineCollection = require('./machineCollection');
exports.ConnectionCollection = require('./connectionCollection');
exports.ProcessCollection = require('./processCollection');
exports.PortCollection = require('./portCollection');
exports.MachineGroupCollection = require('./machineGroupCollection');
exports.ClientGroupMembersCollection = require('./clientGroupMembersCollection');
exports.discriminators = {
  'ResourceReference' : exports.ResourceReference,
  'ResourceReference.ref:machine' : exports.MachineReference,
  'ResourceReference.ref:process' : exports.ProcessReference,
  'ResourceReference.ref:port' : exports.PortReference,
  'ResourceReference.ref:machinewithhints' : exports.MachineReferenceWithHints,
  'ResourceReference.ref:clientgroup' : exports.ClientGroupReference,
  'BaseResource.CoreResource' : exports.CoreResource,
  'HostingConfiguration' : exports.HostingConfiguration,
  'BaseResource.machine' : exports.Machine,
  'ProcessHostingConfiguration' : exports.ProcessHostingConfiguration,
  'BaseResource.process' : exports.Process,
  'BaseResource.port' : exports.Port,
  'BaseResource.clientGroup' : exports.ClientGroup,
  'BaseResource.machineGroup' : exports.MachineGroup,
  'BaseResource.Relationship' : exports.Relationship,
  'BaseResource.rel:connection' : exports.Connection,
  'BaseResource.rel:acceptor' : exports.Acceptor,
  'HostingConfiguration.provider:azure' : exports.AzureHostingConfiguration,
  'ProcessHostingConfiguration.provider:azure' : exports.AzureProcessHostingConfiguration,
  'MapRequest' : exports.MapRequest,
  'MapRequest.map:single-machine-dependency' : exports.SingleMachineDependencyMapRequest,
  'MapRequest.MultipleMachinesMapRequest' : exports.MultipleMachinesMapRequest,
  'MapRequest.map:machine-list-dependency' : exports.MachineListMapRequest,
  'MapRequest.map:machine-group-dependency' : exports.MachineGroupMapRequest
};
