/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The location capability.
 *
 */
class LocationCapabilities {
  /**
   * Create a LocationCapabilities.
   * @property {string} [name] The location name.
   * @property {array} [supportedServerVersions] The list of supported server
   * versions.
   * @property {array} [supportedManagedInstanceVersions] The list of supported
   * managed instance versions.
   * @property {string} [status] The status of the capability. Possible values
   * include: 'Visible', 'Available', 'Default', 'Disabled'
   * @property {string} [reason] The reason for the capability not being
   * available.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LocationCapabilities
   *
   * @returns {object} metadata of LocationCapabilities
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LocationCapabilities',
      type: {
        name: 'Composite',
        className: 'LocationCapabilities',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          supportedServerVersions: {
            required: false,
            readOnly: true,
            serializedName: 'supportedServerVersions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServerVersionCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServerVersionCapability'
                  }
              }
            }
          },
          supportedManagedInstanceVersions: {
            required: false,
            readOnly: true,
            serializedName: 'supportedManagedInstanceVersions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ManagedInstanceVersionCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ManagedInstanceVersionCapability'
                  }
              }
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LocationCapabilities;
