/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The managed server capability
 *
 */
class ManagedInstanceEditionCapability {
  /**
   * Create a ManagedInstanceEditionCapability.
   * @property {string} [name] The managed server version name.
   * @property {array} [supportedFamilies] The supported families.
   * @property {string} [status] The status of the capability. Possible values
   * include: 'Visible', 'Available', 'Default', 'Disabled'
   * @property {string} [reason] The reason for the capability not being
   * available.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagedInstanceEditionCapability
   *
   * @returns {object} metadata of ManagedInstanceEditionCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedInstanceEditionCapability',
      type: {
        name: 'Composite',
        className: 'ManagedInstanceEditionCapability',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          supportedFamilies: {
            required: false,
            readOnly: true,
            serializedName: 'supportedFamilies',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ManagedInstanceFamilyCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ManagedInstanceFamilyCapability'
                  }
              }
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedInstanceEditionCapability;
