/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A managed instance key.
 *
 * @extends models['ProxyResource']
 */
class ManagedInstanceKey extends models['ProxyResource'] {
  /**
   * Create a ManagedInstanceKey.
   * @property {string} [kind] Kind of encryption protector. This is metadata
   * used for the Azure portal experience.
   * @property {string} serverKeyType The key type like 'ServiceManaged',
   * 'AzureKeyVault'. Possible values include: 'ServiceManaged',
   * 'AzureKeyVault'
   * @property {string} [uri] The URI of the key. If the ServerKeyType is
   * AzureKeyVault, then the URI is required.
   * @property {string} [thumbprint] Thumbprint of the key.
   * @property {date} [creationDate] The key creation date.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ManagedInstanceKey
   *
   * @returns {object} metadata of ManagedInstanceKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedInstanceKey',
      type: {
        name: 'Composite',
        className: 'ManagedInstanceKey',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            readOnly: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          serverKeyType: {
            required: true,
            serializedName: 'properties.serverKeyType',
            type: {
              name: 'String'
            }
          },
          uri: {
            required: false,
            serializedName: 'properties.uri',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: false,
            readOnly: true,
            serializedName: 'properties.thumbprint',
            type: {
              name: 'String'
            }
          },
          creationDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.creationDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedInstanceKey;
