/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A recoverable managed database resource.
 *
 * @extends models['ProxyResource']
 */
class RecoverableManagedDatabase extends models['ProxyResource'] {
  /**
   * Create a RecoverableManagedDatabase.
   * @property {string} [lastAvailableBackupDate] The last available backup
   * date.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RecoverableManagedDatabase
   *
   * @returns {object} metadata of RecoverableManagedDatabase
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecoverableManagedDatabase',
      type: {
        name: 'Composite',
        className: 'RecoverableManagedDatabase',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          lastAvailableBackupDate: {
            required: false,
            readOnly: true,
            serializedName: 'properties.lastAvailableBackupDate',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RecoverableManagedDatabase;
