/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A sensitivity label.
 *
 * @extends models['ProxyResource']
 */
class SensitivityLabel extends models['ProxyResource'] {
  /**
   * Create a SensitivityLabel.
   * @property {string} [labelName] The label name.
   * @property {string} [labelId] The label ID.
   * @property {string} [informationType] The information type.
   * @property {string} [informationTypeId] The information type ID.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SensitivityLabel
   *
   * @returns {object} metadata of SensitivityLabel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SensitivityLabel',
      type: {
        name: 'Composite',
        className: 'SensitivityLabel',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          labelName: {
            required: false,
            serializedName: 'properties.labelName',
            type: {
              name: 'String'
            }
          },
          labelId: {
            required: false,
            serializedName: 'properties.labelId',
            type: {
              name: 'String'
            }
          },
          informationType: {
            required: false,
            serializedName: 'properties.informationType',
            type: {
              name: 'String'
            }
          },
          informationTypeId: {
            required: false,
            serializedName: 'properties.informationTypeId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SensitivityLabel;
