/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A server DNS alias.
 *
 * @extends models['ProxyResource']
 */
class ServerDnsAlias extends models['ProxyResource'] {
  /**
   * Create a ServerDnsAlias.
   * @property {string} [azureDnsRecord] The fully qualified DNS record for
   * alias
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServerDnsAlias
   *
   * @returns {object} metadata of ServerDnsAlias
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerDnsAlias',
      type: {
        name: 'Composite',
        className: 'ServerDnsAlias',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          azureDnsRecord: {
            required: false,
            readOnly: true,
            serializedName: 'properties.azureDnsRecord',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServerDnsAlias;
