/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of the table in the database full schema.
 *
 */
class SyncFullSchemaTable {
  /**
   * Create a SyncFullSchemaTable.
   * @property {array} [columns] List of columns in the table of database full
   * schema.
   * @property {string} [errorId] Error id of the table.
   * @property {boolean} [hasError] If there is error in the table.
   * @property {string} [name] Name of the table.
   * @property {string} [quotedName] Quoted name of the table.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SyncFullSchemaTable
   *
   * @returns {object} metadata of SyncFullSchemaTable
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SyncFullSchemaTable',
      type: {
        name: 'Composite',
        className: 'SyncFullSchemaTable',
        modelProperties: {
          columns: {
            required: false,
            readOnly: true,
            serializedName: 'columns',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SyncFullSchemaTableColumnElementType',
                  type: {
                    name: 'Composite',
                    className: 'SyncFullSchemaTableColumn'
                  }
              }
            }
          },
          errorId: {
            required: false,
            readOnly: true,
            serializedName: 'errorId',
            type: {
              name: 'String'
            }
          },
          hasError: {
            required: false,
            readOnly: true,
            serializedName: 'hasError',
            type: {
              name: 'Boolean'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          quotedName: {
            required: false,
            readOnly: true,
            serializedName: 'quotedName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SyncFullSchemaTable;
