/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Stats that are available for all jobs in common
 *
 */
class JobStats {
  /**
   * Create a JobStats.
   * @member {number} [completedWorkItemCount] Completed work item count.
   * @member {number} [totalWorkItemCount] Total work item count.
   * @member {number} [estimatedTimeRemaining] The estimated time remaining.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobStats
   *
   * @returns {object} metadata of JobStats
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobStats',
      type: {
        name: 'Composite',
        className: 'JobStats',
        modelProperties: {
          completedWorkItemCount: {
            required: false,
            serializedName: 'completedWorkItemCount',
            type: {
              name: 'Number'
            }
          },
          totalWorkItemCount: {
            required: false,
            serializedName: 'totalWorkItemCount',
            type: {
              name: 'Number'
            }
          },
          estimatedTimeRemaining: {
            required: false,
            serializedName: 'estimatedTimeRemaining',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = JobStats;
