/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The operation supported by storage sync.
 *
 */
class OperationEntity {
  /**
   * Create a OperationEntity.
   * @property {string} [name] Operation name:
   * {provider}/{resource}/{operation}.
   * @property {object} [display] The operation supported by storage sync.
   * @property {string} [display.description] The description of the operation.
   * @property {string} [display.operation] The action that users can perform,
   * based on their permission level.
   * @property {string} [display.provider] Service provider: Microsoft
   * StorageSync.
   * @property {string} [display.resource] Resource on which the operation is
   * performed.
   * @property {string} [origin] The origin.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationEntity
   *
   * @returns {object} metadata of OperationEntity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationEntity',
      type: {
        name: 'Composite',
        className: 'OperationEntity',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplayInfo'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationEntity;
