/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Post Restore Request
 *
 */
class PostRestoreRequest {
  /**
   * Create a PostRestoreRequest.
   * @property {string} [partition] Post Restore partition.
   * @property {string} [replicaGroup] Post Restore replica group.
   * @property {string} [requestId] Post Restore request id.
   * @property {string} [azureFileShareUri] Post Restore Azure file share uri.
   * @property {string} [status] Post Restore Azure status.
   * @property {string} [sourceAzureFileShareUri] Post Restore Azure source
   * azure file share uri.
   * @property {string} [failedFileList] Post Restore Azure failed file list.
   * @property {array} [restoreFileSpec] Post Restore restore file spec array.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PostRestoreRequest
   *
   * @returns {object} metadata of PostRestoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PostRestoreRequest',
      type: {
        name: 'Composite',
        className: 'PostRestoreRequest',
        modelProperties: {
          partition: {
            required: false,
            serializedName: 'partition',
            type: {
              name: 'String'
            }
          },
          replicaGroup: {
            required: false,
            serializedName: 'replicaGroup',
            type: {
              name: 'String'
            }
          },
          requestId: {
            required: false,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          },
          azureFileShareUri: {
            required: false,
            serializedName: 'azureFileShareUri',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          sourceAzureFileShareUri: {
            required: false,
            serializedName: 'sourceAzureFileShareUri',
            type: {
              name: 'String'
            }
          },
          failedFileList: {
            required: false,
            serializedName: 'failedFileList',
            type: {
              name: 'String'
            }
          },
          restoreFileSpec: {
            required: false,
            serializedName: 'restoreFileSpec',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RestoreFileSpecElementType',
                  type: {
                    name: 'Composite',
                    className: 'RestoreFileSpec'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PostRestoreRequest;
