/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Pre Restore request object.
 *
 */
class PreRestoreRequest {
  /**
   * Create a PreRestoreRequest.
   * @property {string} [partition] Pre Restore partition.
   * @property {string} [replicaGroup] Pre Restore replica group.
   * @property {string} [requestId] Pre Restore request id.
   * @property {string} [azureFileShareUri] Pre Restore Azure file share uri.
   * @property {string} [status] Pre Restore Azure status.
   * @property {string} [sourceAzureFileShareUri] Pre Restore Azure source
   * azure file share uri.
   * @property {string} [backupMetadataPropertyBag] Pre Restore backup metadata
   * property bag.
   * @property {array} [restoreFileSpec] Pre Restore restore file spec array.
   * @property {number} [pauseWaitForSyncDrainTimePeriodInSeconds] Pre Restore
   * pause wait for sync drain time period in seconds.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PreRestoreRequest
   *
   * @returns {object} metadata of PreRestoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PreRestoreRequest',
      type: {
        name: 'Composite',
        className: 'PreRestoreRequest',
        modelProperties: {
          partition: {
            required: false,
            serializedName: 'partition',
            type: {
              name: 'String'
            }
          },
          replicaGroup: {
            required: false,
            serializedName: 'replicaGroup',
            type: {
              name: 'String'
            }
          },
          requestId: {
            required: false,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          },
          azureFileShareUri: {
            required: false,
            serializedName: 'azureFileShareUri',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          sourceAzureFileShareUri: {
            required: false,
            serializedName: 'sourceAzureFileShareUri',
            type: {
              name: 'String'
            }
          },
          backupMetadataPropertyBag: {
            required: false,
            serializedName: 'backupMetadataPropertyBag',
            type: {
              name: 'String'
            }
          },
          restoreFileSpec: {
            required: false,
            serializedName: 'restoreFileSpec',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RestoreFileSpecElementType',
                  type: {
                    name: 'Composite',
                    className: 'RestoreFileSpec'
                  }
              }
            }
          },
          pauseWaitForSyncDrainTimePeriodInSeconds: {
            required: false,
            serializedName: 'pauseWaitForSyncDrainTimePeriodInSeconds',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = PreRestoreRequest;
