/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Subscription State object.
 *
 */
class SubscriptionState {
  /**
   * Create a SubscriptionState.
   * @property {string} [state] State of Azure Subscription. Possible values
   * include: 'Registered', 'Unregistered', 'Warned', 'Suspended', 'Deleted'
   * @property {boolean} [istransitioning] Is Transitioning
   * @property {object} [properties] Subscription state properties.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SubscriptionState
   *
   * @returns {object} metadata of SubscriptionState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubscriptionState',
      type: {
        name: 'Composite',
        className: 'SubscriptionState',
        modelProperties: {
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          istransitioning: {
            required: false,
            readOnly: true,
            serializedName: 'istransitioning',
            type: {
              name: 'Boolean'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = SubscriptionState;
