/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters used when creating a sync group.
 *
 * @extends models['ProxyResource']
 */
class SyncGroupCreateParameters extends models['ProxyResource'] {
  /**
   * Create a SyncGroupCreateParameters.
   * @property {object} [properties] The parameters used to create the sync
   * group
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SyncGroupCreateParameters
   *
   * @returns {object} metadata of SyncGroupCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SyncGroupCreateParameters',
      type: {
        name: 'Composite',
        className: 'SyncGroupCreateParameters',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = SyncGroupCreateParameters;
