/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a TrendingVideos.
 * @extends models['Response']
 */
class TrendingVideos extends models['Response'] {
  /**
   * Create a TrendingVideos.
   * @property {array} bannerTiles
   * @property {array} categories
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TrendingVideos
   *
   * @returns {object} metadata of TrendingVideos
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TrendingVideos',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ResponseBase',
        className: 'TrendingVideos',
        modelProperties: {
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          webSearchUrl: {
            required: false,
            readOnly: true,
            serializedName: 'webSearchUrl',
            type: {
              name: 'String'
            }
          },
          bannerTiles: {
            required: true,
            serializedName: 'bannerTiles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TrendingVideosTileElementType',
                  type: {
                    name: 'Composite',
                    className: 'TrendingVideosTile'
                  }
              }
            }
          },
          categories: {
            required: true,
            serializedName: 'categories',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TrendingVideosCategoryElementType',
                  type: {
                    name: 'Composite',
                    className: 'TrendingVideosCategory'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TrendingVideos;
